  subroutine maincl_new(kaction,iprin)
  USE atomi
  USE General, only: cell,spacegr,celem,vetint,neutro
  USE atom_type_util
  USE variables
  USE connect_mod
  USE molpnew
  USE unit_cell
  USE elements
  implicit none
  integer, intent(in) :: kaction,iprin
  type(atom_type), dimension(:), allocatable :: atom
  integer :: i,nat
  type(cell_type) :: cellt
!
  call xyz_to_atom(atom,xyzs(:3,:nats),bfac,occr=xyzs(5,:),occh=occpch,nz=nz,lab=aLab,elem=celem)
  nat = numatomtype(atom)
  atom%inte = vetint(:nat)
  do i=1,nat
     if (atom(i)%get_nz() < NZCONST .and. atom(i)%get_nz() /= 0) then
         !call atom(i)%set_specie_from_el(1,celem)
         call make_specie(atom,spacegr,celem,neutro)
         exit
     endif
  enddo
  nz(:nat) = atom(:)%get_nz()
  call atom_string(atom,celem)
  cellt = set_cell_type(cell)
  call calcola_occ(atom,spacegr,cellt)
  call create_connectivity(atom,lconn,set_cell_type(cell),spacegr,move=.true.)
  call bond_to_iconn(lconn,iconn)
  izpk(:numatomtype(atom)) = (numelem(celem) - atom(:)%kscatt() + 1)*NZCONST
  call fillatom(atom)
!!!!TODO: check atoms with unresonable distance
!
  end subroutine maincl_new

  subroutine maincl(kaction,iprin)
  USE atomi
  USE General, only: vetint
  implicit none
  integer, intent(in) :: kaction,iprin
  integer :: i
  !call maincl_old(kaction,iprin)
  write(6,*)'===============================CALL MAINCL'
  call maincl_new(kaction,iprin)
  write(6,*)'AT,izpk,nz,xyzs()'
  do i=1,nats
     write(6,'(i5,i5,i5,5f10.3,2x,a,f10.3)')i,izpk(i),nz(i),xyzs(:5,i),aLab(i),vetint(i)
  enddo
  write(6,*)'===============================CALL MAINCL'
  end subroutine maincl
