MODULE commandsmod

   implicit none 

   character(len=1)                  :: beg = '%'      ! controllare se usato
   character(len=1)                  :: commen = '>'   ! controllare se usato
   integer, parameter                :: NUM_COMMANDS = 42
   character(len=*), parameter, dimension(NUM_COMMANDS)  :: allcom = (/      &
     '              ','              ','              ', &  !  3
     'data          ','extraction    ','normal        ', &  !  6
     'seminvariants ','invariants    ','phase         ', &  !  9
     'fourier       ','menu          ','end           ', &  !  12
     'continue      ','              ','sdirect       ', &  !  15
     'polyedra      ','recycle       ','changelabel   ', &  !  18
     'export        ','zmatrix       ','automatic     ', &  !  21
     'patterson     ','ntreor        ','rietveld      ', &  !  24
     'piero         ','coordinates   ','sannel        ', &  !  27
     'structure     ','window        ','nowindow      ', &  !  30
     'initialize    ','job           ','fragment      ', &  !  33
     'save          ','load          ','alltrials     ', &  !  36
     'random        ','refine        ','indexing      ', &  !  39
     'dicvol        ','mcmaille      ','calculate_xpd '/)   !  42

integer, parameter :: DATA_CMD=4, NTREOR_CMD=23, RIET_CMD=24, SA_CMD=27
integer, parameter :: EXTRA_CMD=5, NORM_CMD=6, INVAR_CMD=8, PHASE_CMD=9, FOUR_CMD=10, MENU_CMD=11, END_CMD=12
integer, parameter :: FRAG_CMD=33, SAVE_PRJ=34, LOAD_PRJ=35, DICVOL_CMD=40, MCMAILLE_CMD=41
integer, parameter :: CALCXPD_CMD=42

!
!   contvet = 0 se il comando non necessita del contenuto
!   contvet = 1 se il comando necessita del contenuto
!   contvet = 2 ulteriore controllo e' necessario
    integer, dimension(NUM_COMMANDS) :: contvet = (/  &
                0 , 0 , 0 ,                 &  !  3
                2 , 1 , 1 ,                 &  !  6
                1 , 1 , 0 ,                 &  !  9
                0 , 0 , 1 ,                 &  ! 12
                1 , 1 , 1 ,                 &  ! 15
                0 , 1 , 0 ,                 &  ! 18
                0 , 0 , 0 ,                 &  ! 21
                1 , 0 , 0 ,                 &  ! 24
                0 , 0 , 0 ,                 &  ! 27
                0 , 0 , 0 ,                 &  ! 30
                0 , 0 , 0 ,                 &  ! 33
                0 , 0 , 1 ,                 &  ! 36
                1 , 1 , 0 ,                 &  ! 39
                0 , 0 , 0/)                    ! 42
!
!   kit       = 0 Powders Kit
   integer, parameter :: kit = 0
   integer, parameter :: NLENDIR = 780
   integer, parameter :: NMAXDIR = 20
   type command_type
        integer                                    :: code = 0     !  codice comando
        character(len=NLENDIR), dimension(NMAXDIR) :: strdir = ' ' !  stringa con direttiva
        integer                                    :: ndir = 0     !  num. di direttive
   contains
        procedure, private :: set_command_str
        procedure, private :: set_command_ip
        generic, public    :: set => set_command_str, set_command_ip
        procedure          :: getdir 
        procedure          :: prn

   end type command_type

   type(command_type), dimension(:), allocatable :: commands

CONTAINS
   
   subroutine create_commands(commd,ipcom,icomqq,cardq)
   type(command_type), dimension(:), allocatable, intent(inout) :: commd
   integer, intent(in)                                          :: ipcom
   integer, dimension(:,:), intent(in)                          :: icomqq
   character(len=*), dimension(:)                               :: cardq
   integer                                                      :: i    !!!old,j
!old   integer                                                      :: icd
   integer                                                      :: icd1,icd2
!
   if (allocated(commd)) deallocate(commd)
   allocate(commd(ipcom))
!old   icd = 0
!old   do i=1,ipcom
!old      commd(i)%code = icomqq(i,1)
!old!corr      commd(i)%ndir =icomqq(i,2)
!old      commd(i)%ndir =min(icomqq(i,2),NMAXDIR)
!old      if (commd(i)%ndir /= 0) then
!old!corr          allocate(commd(i)%strdir(commd(i)%ndir))
!old          do j=1,commd(i)%ndir
!old             icd = icd + 1
!old             commd(i)%strdir(j) = cardq(icd)
!old          enddo
!old      endif
!old   enddo
!!!!!FIXME 
   icd2 = 0
   do i=1,ipcom
      if (icomqq(i,2) > 0) then
          icd1 = icd2 + 1
          icd2 = icd2 + icomqq(i,2)
          call commd(i)%set(allcom(icomqq(i,1)), cardq(icd1:icd2))
      else
          call commd(i)%set(allcom(icomqq(i,1)))
      endif
   enddo
!
   end subroutine create_commands

!-----------------------------------------------------------------------------------------

   subroutine create_expo_commands(commd, ipcom, icomq, card)
   type(command_type), dimension(:), intent(in) :: commd
   integer, intent(out) :: ipcom
   integer, dimension(:,:) :: icomq
   character(len=*), dimension(:) :: card
   integer :: ncd
   integer :: i,j
!   
   ipcom = size(commd)
   ncd = 0
   do i=1, ipcom
      icomq(i,1) = commd(i)%code
      icomq(i,2) = commd(i)%ndir
      do j=1,commd(i)%ndir
         ncd = ncd + 1
         card(ncd) = trim(commd(i)%strdir(j))
      enddo
   enddo
!
   end subroutine create_expo_commands

!-----------------------------------------------------------------------------------------

   integer function ncommands(commd)
!
!  Numero di comandi
!
   type(command_type), dimension(:), allocatable, intent(in) :: commd
!
   if (allocated(commd)) then
       ncommands = size(commd)
   else
       ncommands = 0
   endif
!
   end function ncommands

!-----------------------------------------------------------------------------------------

   integer function command_position(commd,stringcomm,back)  result(nposc)
!
!  Cerca un comando nella lista e ne restituisce la posizione
!  il risultato è 0 se non esiste
!
   USE strutil
   type(command_type), dimension(:), allocatable, intent(in) :: commd
   character(len=*), intent(in)                              :: stringcomm
   logical, intent(in), optional                             :: back
!
   if (ncommands(commd) == 0) then
       nposc = 0
   else
       if (present(back)) then
           nposc = position_stringv(stringcomm,allcom(commd(:)%code),back)
       else
           nposc = position_stringv(stringcomm,allcom(commd(:)%code))
       endif
   endif
!
   end function command_position

!-----------------------------------------------------------------------------------------

   integer function is_directive(commd,dirstring)
!
!  controlla l'esistenza di una direttiva nel comando commd
!
   USE strutil
   type(command_type), intent(in)                    :: commd
   character(len=*), intent(in)                      :: dirstring
   character(len=NLENDIR), dimension(:), allocatable :: commdir
   character(len=NLENDIR)                            :: strd
   integer                                           :: i
   integer                                           :: nlend
!
   if (commd%ndir > 0) then
!
!      Isola la prima stringa per ogni direttiva
       allocate(commdir(commd%ndir))
       do i=1,commd%ndir
          strd = commd%strdir(i)
          call cutst(strd,line2=commdir(i))
          nlend = min(4,len_trim(commdir(i))) 
          commdir(i) = commdir(i)(1:nlend)  ! prendi non + di 4 caratteri
       enddo
!
       nlend = min(4,len_trim(dirstring))
       is_directive = position_stringv(dirstring(1:nlend),commdir)
   else
       is_directive = 0
   endif
!
   end function is_directive

!-----------------------------------------------------------------------------------------

   function get_directive(commd,dirstring)  result(isdir)
!
!  Estrai una direttiva
!
   type(command_type), dimension(:), intent(in) :: commd
   character(len=*), intent(in)                 :: dirstring
   integer                                      :: i
   integer, dimension(2)                        :: isdir
   integer                                      :: kdir
!
   isdir(:) = 0
   do i=1,size(commd)  
      kdir = is_directive(commd(i),dirstring)
      if (kdir > 0) then
          isdir(1) = i
          isdir(2) = kdir
          exit
      endif
   enddo
!
   end function get_directive

!-----------------------------------------------------------------------------------------

   function get_string_directive(commd,dirstring) result(str)
!
!  Estrai la stringa associata ad una direttiva
!
   USE strutil
   type(command_type), dimension(:), intent(in) :: commd
   character(len=*), intent(in)                 :: dirstring
   character(len=NLENDIR)                       :: str
   integer, dimension(2)                        :: kdir
!
   kdir(:) = get_directive(commd,dirstring)
   if (kdir(1) > 0) then
       str = trim(commd(kdir(1))%strdir(kdir(2)))
       call cutst(str)
   else
       str = ' '
   endif
!
   end function get_string_directive

!-----------------------------------------------------------------------------------------

   logical function is_directive_cmd(commd, dirstring)
!
!  Esiste la direttiva dirstring?
!
   type(command_type), dimension(:), intent(in) :: commd
   character(len=*), intent(in)                 :: dirstring
   integer, dimension(2)                        :: isdir
!
   isdir(:) = get_directive(commd,dirstring)
   is_directive_cmd = isdir(1) > 0
!
   end function is_directive_cmd

!-----------------------------------------------------------------------------------------

    logical function is_directive_in_command(commd,strcomm,strdir)   result(isdir)
!
!   Controlla se esiste la direttiva strdir nel comando strcomm
!
    type(command_type), dimension(:), allocatable, intent(in) :: commd
    character(len=*), intent(in)                              :: strcomm,strdir
    integer                                                   :: nposc
    integer, dimension(2)                                     :: kdir
!
!   Locazione del comando strcomm
    nposc = command_position(commd,strcomm)
!
    if (nposc > 0) then
        kdir(:) = get_directive(commd(nposc:nposc),strdir) 
        isdir = kdir(1) > 0
    else
        isdir = .false.
    endif
!
    end function is_directive_in_command

!-----------------------------------------------------------------------------------------

   subroutine prn(cmd,kpr)
   class(command_type), intent(in) :: cmd
   integer, intent(in)             :: kpr
   integer                         :: j
!
   write(kpr,'(a)')'%'//trim(allcom(cmd%code))
   do j=1,cmd%ndir
      write(kpr,'(a)')trim(cmd%strdir(j))
   enddo
!
   end subroutine prn

!-----------------------------------------------------------------------------------------

   subroutine print_commands(commd,kpr)
!
!  Print all commands
!
   type(command_type), dimension(:), allocatable, intent(in) :: commd
   integer, intent(in)                                       :: kpr
   integer                                                   :: i
!
   do i=1,ncommands(commd)
      call commd(i)%prn(kpr)
!corr      write(kpr,*)'%'//trim(allcom(commd(i)%code))
!corr      do j=1,commd(i)%ndir
!corr         write(kpr,*)trim(commd(i)%strdir(j))
!corr      enddo
   enddo
!
   end subroutine print_commands

!-----------------------------------------------------------------------------------------

   logical function is_content_required(commd) result(lreq)
!
!  Controllo se il contenuto e' necessario
!
   type(command_type), dimension(:), allocatable, intent(in) :: commd
   integer                                                   :: i
!
   lreq = .false.
!
   do i=1,ncommands(commd)
      select case (contvet(commd(i)%code))
         case (1)   ! il comando richiede il contenuto
           lreq = .true.
           exit 

         case (2)   ! esegui un controllo
           if (commd(i)%code == 2) then   ! comando 'data'
!
!             Se esiste la direttiva findspace il contenuto e' richiesto
              if (is_directive(commd(i),'findspace') > 0) then
                  lreq = .true.
                  exit
              endif 
           endif
      end select
   enddo
!
   end function is_content_required

!-----------------------------------------------------------------------------------------

   subroutine set_command_str(commd, strcomm, dir)
   USE strutil
   class(command_type), intent(out)         :: commd
   character(len=*), intent(in)             :: strcomm
   character(len=*), dimension(:), optional :: dir
   integer                                  :: i
   integer                                  :: poscom
!
   poscom = 0
   do i=1,size(allcom)
      if (match_word(allcom(i),strcomm)) then
          poscom = i
          exit
      endif
   enddo
   call set_command_ip(commd,poscom,dir)
!corr   if (poscom > 0) then
!corr       commd%code = poscom 
!corr       commd%ndir = 0
!corr       if (present(dir)) then
!corr           do i=1,size(dir)
!corr              if (len_trim(dir(i)) > 0) then
!corr                  commd%ndir = commd%ndir + 1
!corr                  commd%strdir(i) = dir(i)
!corr                  if (commd%ndir > NMAXDIR) exit
!corr              endif
!corr           enddo
!corr       endif
!corr   endif
!
   end subroutine set_command_str

 !-----------------------------------------------------------------------------------------

   subroutine set_command_ip(commd, poscom, dir)
   USE strutil
   class(command_type), intent(out)         :: commd
   integer, intent(in)                      :: poscom
   character(len=*), dimension(:), optional :: dir
   integer                                  :: i
!
   if (poscom > 0) then
       commd%code = poscom 
       commd%ndir = 0
       if (present(dir)) then
           do i=1,size(dir)
              if (len_trim(dir(i)) > 0) then
                  commd%ndir = commd%ndir + 1
                  commd%strdir(i) = dir(i)
                  if (commd%ndir > NMAXDIR) exit
              endif
           enddo
       endif
   endif
!
   end subroutine set_command_ip
  
!-----------------------------------------------------------------------------------------

   subroutine set_command_for(strcomm,ipcom,icomqq)
   USE strutil
   character(len=*), intent(in)           :: strcomm
   integer, intent(inout)                 :: ipcom
   integer, dimension(:,:), intent(inout) :: icomqq
   integer                                :: i, lens
!
   lens = len_trim(strcomm)
   do i=1,size(allcom)
      if (lower(strcomm) == allcom(i)(1:lens)) then
          ipcom = ipcom + 1
          icomqq(ipcom,1) = i
          icomqq(ipcom,2) = 0
      endif
   enddo
!
   end subroutine set_command_for

!-----------------------------------------------------------------------------------------

   function getdir(commd,kdir) result(dir)
   class(command_type), intent(in) :: commd
   integer, intent(in), optional   :: kdir
   character(len=NLENDIR)          :: dir
   integer                         :: kdirective
   if (present(kdir)) then
       kdirective = kdir
   else
       kdirective = 1
   endif
   if (kdirective <= commd%ndir .and. kdirective > 0) then
       dir = trim(commd%strdir(kdirective))
   else
       dir = ' '
   endif
   end function getdir

!-----------------------------------------------------------------------------------------

   logical function command_is(commd,icpos,scomm)  result(is_commd)
!
!  Check if the command icpos is scomm
!
   USE strutil
   type(command_type), dimension(:), allocatable, intent(in) :: commd
   integer, intent(in)                                       :: icpos  ! current command position
   character(len=*), intent(in)                              :: scomm  ! command name
!
   is_commd = .false.
   if (ncommands(commd) < icpos) return
   is_commd = s_eqi(allcom(commd(icpos)%code),scomm)
!
   end function command_is

!-----------------------------------------------------------------------------------------

   logical function next_command_is(commd,icpos,scomm)   result(is_commd)
!
!  Check if the next command icpos+1 is scomm
!
   USE strutil
   type(command_type), dimension(:), allocatable, intent(in) :: commd
   integer, intent(in)                                       :: icpos  ! current command position
   character(len=*), intent(in)                              :: scomm  ! command name
   integer                                                   :: ic_next
!
!corr   is_commd = .false.
   ic_next = icpos + 1  ! next command position
!corr   if (ncommands(commd) < ic_next) return
!corr   is_commd = s_eqi(allcom(commd(ic_next)%code),scomm)
   is_commd = command_is(commd,ic_next,scomm)
!
   end function next_command_is
  
!-----------------------------------------------------------------------------------------

   subroutine resize_cmd(vetr,n,savevet)
!
!  Rialloca ad n un array di tipo command_type
!  Se savevet = .true. o non esiste si salva il suo contenuto.
!
   type(command_type), allocatable, intent(inout) :: vetr(:)
   integer, intent(in)                            :: n
   logical, optional, intent(in)                  :: savevet
   logical                                        :: savev
   integer                                        :: nv
   type(command_type), allocatable                :: vsav(:)
   integer                                        :: nsav
!
!  se n = 0 (riallocazione a 0): dealloca ed esci
   if (n == 0) then
       if (allocated(vetr)) deallocate(vetr)
       return
   endif
!
   if (.not.allocated(vetr)) then
       allocate(vetr(n))
   else
!
       nv = size(vetr)
       if (present(savevet)) then
           savev = savevet
       else
           savev = .true.
       endif
!
       if (savev) then
!
!          nsav contiene qual e' la porzione di vetr da salvare
           select case(nv-n)
             case (1:)       ! compatta x ad n
               nsav = n
             case (:-1)      ! espandi x ad n
               nsav = nv
             case (0)
               return        ! n=nv non fare niente
           end select
           allocate(vsav(n))
           vsav(:nsav) = vetr(:nsav)
           call move_alloc(vsav,vetr)
       else
           deallocate(vetr)
           allocate(vetr(n))
       endif
   endif
!
   end subroutine resize_cmd

!-----------------------------------------------------------------------------------------

   subroutine new_cmd(vetr,n)
!
!  Create new atoms
!
   type(command_type), allocatable, intent(inout) :: vetr(:)
   integer, intent(in)                            :: n

   if (n < 0) return
   if (ncommands(vetr) /= n) then
       if (allocated(vetr))deallocate(vetr)
       if (n > 0) allocate(vetr(n))
   endif

   end subroutine new_cmd

!-----------------------------------------------------------------------------------------

   subroutine delete_cmd(vetr)
!
!  Delete all atoms
!
   type(command_type), allocatable, intent(inout) :: vetr(:)

   if (allocated(vetr)) deallocate(vetr)

   end subroutine delete_cmd

!----------------------------------------------------------------------------------------------------
  
   subroutine add_directive(comm,sdir)
!
!  Add diective sdir(:) to the command comm
!
   type(command_type), intent(inout)          :: comm
   character(len=*), dimension(:), intent(in) :: sdir
   integer                                    :: i
!   
   do i=1,size(sdir)
      if (is_directive(comm,sdir(i)) == 0)  then
          comm%ndir = comm%ndir + 1
          comm%strdir(comm%ndir) = sdir(i)
          if (comm%ndir > NMAXDIR) exit
      endif
   enddo
!
   end subroutine add_directive

!----------------------------------------------------------------------------------------------------

   subroutine add_continue(comm,ipstart)
!
!  Add command for '%continue' starting from ipstart+1
!
   type(command_type), allocatable, intent(inout) :: comm(:)
   integer, intent(in)                            :: ipstart
   integer, dimension(7), parameter               :: vetc = [EXTRA_CMD,NORM_CMD,INVAR_CMD,PHASE_CMD,FOUR_CMD,MENU_CMD,END_CMD]
   integer                                        :: inic,finc,icomm,kadd,i
!
!  Check if ipstart is one of the command in the array vetc
   icomm = 0
   if (ipstart > 0) then
       do i=1,size(vetc)  
          if (comm(ipstart)%code == vetc(i)) then
              icomm = i
              exit
          endif
       enddo
   endif
!
   kadd = size(vetc) - icomm ! commands to add
   call resize_cmd(comm,ipstart+kadd)
!
   inic = ipstart+1
   finc = inic 
   do i=1,kadd
      call comm(ipstart+i)%set(vetc(icomm+i))
   enddo
!
   end subroutine add_continue

END MODULE commandsmod
