   subroutine open_diffraction_patt(filnam, ier)
   USE fileutil
   USE General, only: StructureName, fname, ext, INP_FILE, OUT_FILE     !!!!!, alambda
   USE datasetmod
   USE molcom, only:ifProject
   USE strutil
   USE General, only:lo
   USE variables, only: dataset
   implicit none
   character*(*), intent(in) :: filnam
   integer                   :: ier
!corr   type(dataset_type)        :: dataset
   integer                   :: iflag
   integer                   :: itype, iform, nlenn, jop, jopen, ier2
   integer                   :: i
!
   call dataset%open_file(filnam,ier) 
   if (ier == 0) then
       if (ifProject.ne.0) then   ! importante se esegui run successivi
           iflag = 2
           call chiudi_bin(iflag)
       endif
       StructureName = file_rem_ext(file_get_name(filnam))
       do i=1,size(fname)
          if (i /= INP_FILE .and. i /= OUT_FILE) then
              fname(i) = s_blank_delete(trim(StructureName)//ext(i))
          endif
       enddo
       fname(INP_FILE) = trim(filnam)
       fname(OUT_FILE) = trim(file_rem_ext(filnam))//ext(OUT_FILE)
!
       close(lo,iostat=ier)
       itype = 0
       iform = 1
       nlenn = 80
       jop = jopen(lo,fname(OUT_FILE),itype,iform,ier2)
!
       call work_on_pattern(dataset,filnam)
!
   endif
!
   return
   end

!---------------------------------------------------------------------------

   subroutine open_pattern(filnam,wavel,radtype,ier)
   USE datasetmod
   USE General, only: StructureName
   USE fileutil
   USE variables, only: dataset
   implicit none
   character(len=*), intent(in) :: filnam
   real, intent(in)             :: wavel
   integer, intent(in)          :: radtype
   integer, intent(out)         :: ier
!corr   type(dataset_type)           :: dataset
!
   call dataset%open_file(filnam,ier,wavel)
   if (ier == 0) then
       StructureName = file_rem_ext(file_get_name(filnam))
       call work_on_pattern(dataset,filnam)
   endif
!
   end subroutine open_pattern

!---------------------------------------------------------------------------

   subroutine work_on_pattern(dataset,filnam)
   USE fileutil
   USE Conteggi
   USE patternref
   USE view
   USE messagemod
   USE enable_amb
   USE strutil
   USE datasetmod
   USE molcom, only: jscreen
       !USE proginterface
   implicit none
   type(dataset_type), intent(in) :: dataset
   character(len=*), intent(in)   :: filnam
!
   call dataset_to_expo(dataset)

   if (jscreen > 0) then
       call AbilitaPaned(1)
       call init_messages()
       call write_message_pattern(filnam)
       call vedinew(1,1,npunti)
       call abilita_tasti('pattern')
              call wmenu_set_state('Range'//char(0),1)
       call SetWindowTitle(filnam)
!corr       call abilita_tasti('structure')
       call toolbar_set_state('continue'//char(0),2)
   endif

   call init_dati()
!
!  create background FIXME-non serve se fai una open_background
!   call fillcounts()
!   call back_for_peaksearch()
!!!!!test peak search
   !     call test_peaksearch()
!!!!!test peak search

!!!!!!!!!!!!!!!prova index
      !call run_indexing(filehpow, alambda, 'mcmaille')
      !call run_indexation(filehpow, alambda, 'dicvol')
      !call run_indexation(filehpow, alambda, 'ntreor')
!!!!!!!!!!!!!!!prova index

   end subroutine work_on_pattern

!---------------------------------------------------------------------------

!   subroutine test_peaksearch()
!   USE peak_mod
!   USE messagemod
!   USE Conteggi
!   USE view
!   USE proginterface, only:fillcounts
!!corr   USE indexing
!   integer :: ier
!   common /ksearch/ ksearch
!   integer :: ksearch
!   call fillcounts()
!   call back_for_peaksearch()
!   !call peaksearch(shiftzero,ier)
!   ksearch = 1
!   call peak1(ier)
!   call vedinew(5,1,npunti)
!   call write_message('Number of peaks: ',inum=npk,pos=2)
!   end subroutine test_peaksearch

!---------------------------------------------------------------------------
   
   subroutine dataset_to_expo(dataset)
   USE datasetmod
   USE General, only:alambda, neutro, nsyn
   USE patternref, only:filehpow
   USE arrayutil
   USE indexing
   implicit none
   type(dataset_type), intent(in) :: dataset
   !npunti = sizealloc(dataset%x)
   if (size_array(dataset%x) > 0) then
       call dataset_to_thetaint(dataset)
       !corr thmin = dataset%x(1)
       !corr thmax = dataset%x(npunti)
       !corr thstep = dataset%tstep
       !corr call AllocaConteggi(2)
       !corr call AllocaConteggi(1)
       !corr theta_int(:,1) = dataset%x(:)
       !corr theta_int(:,2) = dataset%y(:)
       !corr theta_int(:,7) = theta_int(:,1)
       !corr theta_int(:,3:6) = 0.0
       alambda = dataset%wave
       call init_indexation(alambda)
       filehpow = trim(dataset%fname)
       select case(dataset%radtype)
          case (2)     ! synchrothron
            nsyn = 1
            neutro = 0
          case (3)     ! neutron 
            nsyn = 0
            neutro = 1
          case default
            neutro = 0
            nsyn = 0
       end select
   endif
   end subroutine dataset_to_expo

!---------------------------------------------------------------------------

   subroutine dataset_to_thetaint(dataset)
   USE Conteggi
   USE PatternRef
   USE arrayutil
   USE datasetmod
   implicit none
   type(dataset_type), intent(in) :: dataset
!
   call AllocaConteggi(2)
   npunti = size_array(dataset%x)
   call AllocaConteggi(1)
   theta_int(:,1) = dataset%x
   theta_int(:,2) = dataset%y
   theta_int(:,7) = theta_int(:,1)
   theta_int(:,3:6) = 0.0
   thstep = dataset%tstep
   thmin = dataset%tmin
   thmax = dataset%tmax
!
   end subroutine dataset_to_thetaint

!---------------------------------------------------------------------------

   subroutine expo_to_dataset(dataset)
   USE datasetmod
   USE Conteggi
   USE General, only:alambda,nsyn,neutro
   USE patternref, only:thmin,thmax,filehpow,thstep
   implicit none
   type(dataset_type), intent(inout) :: dataset
   call dataset%set_data(theta_int(:,1), theta_int(:,2),npunti,filehpow)
   dataset%wave = alambda
   dataset%tstep = thstep
   if (nsyn == 1) then
       dataset%radtype = 2
   elseif (neutro == 1) then
       dataset%radtype = 3
   else
       dataset%radtype = 1
   endif
   end subroutine expo_to_dataset

!---------------------------------------------------------------------------
   subroutine GenInfoV2
   USE General
   USE Symmetry     
   USE Molcom      
   USE PhaseModule 
   USE Conteggi, only:npunti
   USE spginfom
   USE strutil
   !USE proginterface
   USE elements
   USE sinterface
   USE atom_type_util
   USE variables, only:atm,ref
   USE stat
   USE reflection_type_util
!corr   USE sfacmod
   USE Patternref, only: thmin,thmax,thstep
   USE unit_cell
!
   implicit none
   dimension ipos(302),cfom(302),fom(11),ep(2000),iphb(2000)
   real :: fom,cfom,ep,vcell
   integer :: lsn,lfw,llw,lpb,ll16,ipos,iphb
   integer :: i,j,natom
   character(len=100) :: strop
!
   write(iscra,'(" Pattern information:")')
   write(iscra,'(" Nr. of counts =",i6)')npunti
   write(iscra,'(" 2thetamin =",f9.3," 2thetamax =",f9.3," step =",f9.3)')thmin,thmax,thstep
   write(iscra,'(" Wavelength =",f10.6)') alambda
   write(iscra,*)
!
   if (all(cell(1:6) > 0)) then
!corr       write(iscra,'(" Cell parameters:")')
!corr       write(iscra,'("     a = ",f9.3,"     b = ",f9.3,"     c = ",f9.3)') (cell(i),i=1,3)
!corr       write(iscra,'(" alpha = ",f9.3,"  beta = ",f9.3," gamma = ",f9.3)') (cell(i),i=4,6)
!corr       vcell = cell_volume(cell(1:6))
!corr       write(iscra,'(" Cell volume: ",f0.2/)') vcell
       call print_cell(cell,kpr=iscra)
       write(iscra,*)
   endif
!
   if (spacegr%num > 0) then
      if (icent == 0) then
          write(iscra,'(a)')' Space Group Symbol: '//trim(spaceg_string())//' (noncentrosymmetric)'
      else
          write(iscra,'(a)')' Space Group Symbol: '//trim(spaceg_string())//' (centrosymmetric)'
      endif
      write(iscra,'(a,i0/)')' Spacegroup number: ',spacegr%num
      write(iscra,'(" Symmetry operations:")')
      do i=1,nsymtot
         call symop_to_string(symop_type(kmat(i,:,:),tmat(i,:)),strop)
         write(iscra,'(1x,i3,")",1x,a)')i,trim(strop)
      enddo
      call xprtcond(1,iscra)      !!mr250907
      write(iscra,*)
   endif
!
   if(numelem(celem) > 0) then
      call print_elements(celem,iscra,neutro)
      write(iscra,*)
   endif
!
   if(abs(slopeWils).gt.0.0) then
       write(iscra,'(" Wilson Thermal Factor B(iso) = ",f7.3)') bt
       write(iscra,*)
   endif
!
   if (numset > 0) then
       call srlin(16,lsn,lfw,llw,lpb,ll16)
       if (lfw.gt.0) then
           write(iscra,'("                        Figures of Merit")')
           write(iscra,'("   Set  (trial)",1x,"  mabs  alcomb R(x,y)"," cphase  cfom",3x,"nund")')
           call ysfl16(cfom,ipos,nset)
           do j=1,nset
              i = ipos(j)
              call snr16(i,fom,ep,iphb)
              write(iscra,'(i6,"  (",i5,")",5f7.3,i6)') j,nint(fom(10)),(fom(i),i=1,5),nint(fom(6))
           enddo
       endif
       write(iscra,*)
   endif
!
   natom = numatomtype(atm)
   if (natom > 0) then  
       write(iscra,'(" Nr. of atoms in the asymmetric unit: ",i0)')natom
       if (nrefl > 0 .and. allocated(ref)) then
           call fcalcang(ref,atm,spacegr,celem)
           if (knw == 1) then
               erre = Rvalue(ref%fv,ref%fc)
           else
               erre = Rvalue(ref%fo,ref%fc)
           endif
           write(iscra,'(" R-f Fit: ",f0.3)') erre
       endif
       call print_atoms(atm,height=.true.,kpr=iscra)
       vcell = cell_volume(cell)
       write(iscra,'(" Volume per atom: ",f0.2," °A3")')volume_per_atom(atm,nsymtot,vcell)
       write(iscra,'(" Density:         ",f0.2," g/cm3")')    &
       density_value(molecular_weight(atm%ptab,atm%och*atm%ocry),vcell,nsymtot)
   endif
!
   end subroutine GenInfoV2

! -----------------------------------------------------------------

   subroutine run_indexing(sprog)
   USE indexing
   USE timer
   USE general, only: lo
   USE progtype, only: DISTRIBUTED_VER
   implicit none
   character(len=*), intent(in)                    :: sprog
   type(cell_info_type), dimension(:), allocatable :: pcell
   integer                                         :: ier
   logical                                         :: test = .true.
   type(timer_type)                                :: timeind
!   
   call timeind%set_as_elapsed()
   call timeind%tic()
   select case (sprog)
      case ('dicvol')
        call timeind%set_name(PINDEX_NAME(DICVOL06_PROG))
        call run_dicvol(indx_set(DICVOL06_PROG),pcell)
        call add_to_cell_list(cell_list,pcell)
      case ('mcmaille')
        call timeind%set_name(PINDEX_NAME(MCMAILLE_PROG))
        call run_mcmaille(indx_set(MCMAILLE_PROG),pcell)
        call add_to_cell_list(cell_list,pcell)
      case default
        !call ntreor(.false.,ier)
        !    write(0,*)'NTTREOR run'
        call timeind%set_name(PINDEX_NAME(NTREOR09_PROG))
        call run_ntreor(.false.,ier)
   end select
   call timeind%toc()
   call timeind%tprint(lo)
   call timeind%tprint(0)
!
   if (test .and. .not.DISTRIBUTED_VER) call test_indexing(cell_list)
!    
   end subroutine run_indexing

! -----------------------------------------------------------------

   subroutine save_cell_list(filnam)
!
!  Save cell list in a exp or txt file
!
   USE indexing
   USE fileutil
   USE strutil
   USE programinput
   implicit none
   character (len=*) :: filnam
   type(file_handle) :: cf
!
   filnam = remc0(filnam)
   if (s_eqi(get_extension(filnam),'exp')) then
       call write_input_file(input_file_create(filnam),'space',cell_list) 
   else
       call cf%fopen(filnam,'w')
       call print_cell_list(cell_list,cf%handle())
       call cf%fclose()
   endif
!
   end subroutine save_cell_list

MODULE datamod

implicit none

CONTAINS

   subroutine manage_filefc(refob,ier)   
   USE General, only:nrefl, alambda, fname, FC_FILE, dtor, neutro, spacegr, celem
   USE filereading
   USE errormod
   USE importexport
   USE fileutil
   USE TestModel
   USE reflection_type_util
   USE atom_type_util
   USE strutil
   USE symmetry, only:kmat, nsymtot
   USE elements, only:H_at
   USE connect_mod
   implicit none
   type(reflection_type), dimension(:), intent(inout) :: refob
   integer, intent(out)                               :: ier
   type(reflection_type), allocatable, dimension(:)   :: reffc
   type(error_type)                                   :: error
   integer                                            :: nrfc
   integer                                            :: fase
   integer                                            :: i,j
   type(bond_type), dimension(:), allocatable         :: legpub
   integer, dimension(3)                              :: hkl
   integer                                            :: is
!
   ier = 0
   if (s_eqi(get_extension(fname(FC_FILE)),'fc')) then    ! read F from .fc file
       refob(:)%fv = 0
       call read_reflection_file(fname(FC_FILE),reffc,nrfc,'fc',error)
       if (error%signal) then
           call error%print()
           ier = 1
       else
           do i=1,nrfc
              loop_sym: do is=1,nsymtot
                 hkl(:) = matmul(reffc(i)%hkl,kmat(is,:,:))
                 do j=1,nrefl
                    if (all(hkl == refob(j)%hkl)) then
                        fase=mod(reffc(i)%ph,360)
                        if(fase <= 0)fase=fase+360
                        refob(j)%fv = reffc(i)%fc
                        refob(j)%phv=refob(j)%phv+fase*32
                        exit loop_sym
                    endif
                 enddo
              enddo loop_sym
           enddo
       endif
   else                                                   ! try to read structure file
       allocate(reffc(nrefl))
       reffc(:) = refob(:nrefl)
       reffc(:)%slaq = (sin(0.5*refob(:nrefl)%tthd*dtor)/alambda)**2
       call import_structure(fname(FC_FILE),0,atmpub,legpub,.false.,ier)
       if (ier == 0) then   ! now compute F
           call fcalcang(reffc,atmpub,spacegr,celem)
           do i=1,nrefl
              fase=mod(reffc(i)%ph,360)
              if(fase <= 0)fase=fase+360
              refob(i)%fv=reffc(i)%fc
              refob(i)%phv=refob(i)%phv+fase*32
           enddo
           if (neutro == 0) call remove_atoms_from_list(atmpub,atmpub%ptab,H_at)  ! remove H atoms
           nCoordPub = numatomtype(atmpub)
       endif
   endif
!
   end subroutine manage_filefc

!-------------------------------------------------------------------

   subroutine set_wavelength(iwave,wavelength)
   USE General, only:alambda, ERR_WINDOW
   USE indexing
   integer, intent(inout) :: iwave      ! 1 if wavelength exists
   real, intent(in)       :: wavelength
   integer                :: exitcode
   integer                :: ier
   if (iwave == 0 .and. wavelength > 0) then
       !write(0,*)'wavel=',wavelength,iwave
       alambda = wavelength
       call yfrm03(alambda,ier)
       iwave = 1
       call init_indexation(alambda)
   endif
   if (iwave == 0) then
       call MsgWinErr('ERROR','No wavelength supplied',ERR_WINDOW,exitcode)
   endif
   end subroutine set_wavelength

END MODULE datamod

   subroutine run_peaksearch()
   USE Conteggi, only: npunti, theta_int
   USE counts, only:backgr,deltatval,deltadval,delta_from_lambda
   USE peak_mod
   USE arrayutil
   USE proginterface, only:fillcounts
   USE General, only:alambda
   implicit none
   real, dimension(npunti) :: yc
   real, parameter         :: SRANGE = 0.15 ! 2theta-range for peak_search at 1.54056
!
!  Subtract background
   if (.not.allocated(backgr)) then
       call fillcounts()
       call back_for_peaksearch(.true.)
   endif
   !where (backgr(:) > theta_int(:,2)) 
   !       yc(:) = 0
   !elsewhere
           yc(:) = theta_int(:,2) - backgr(:)
   !endwhere
!
!  compute srange
   pkcond%srange = init_peak_range(theta_int(:,1),theta_int(:,2),alambda)
   !write(0,*)'SRANGE =',pkcond%srange
!
   call peak_create(theta_int(:,1),yc,pkind,pkcond,pkindtot)
   pkcond%maxpk = -1 ! unset max number of peaks for GUI
   pkcond%minpk = -1 ! unset min number of peaks for GUI
!
   call update_peak_graph()
!
   end subroutine run_peaksearch

! ---------------------------------------------------------------------

   subroutine run_peaksearchwin()
!
!  When the user press the button 'Pattern' > 'Peak search'
!
   USE patternref, only: thmin,thmax
   USE peak_mod
!
!  Reset the range to create the array pkindtot
   pkcond%minp = thmin
   pkcond%maxp = thmax
!
   call run_peaksearch()
   end subroutine run_peaksearchwin

! ---------------------------------------------------------------------

   subroutine update_peak_graph()
   USE molcom, only: jscreen
   USE enable_amb
   USE messagemod
   !USE peak_util
   USE peak_mod
   USE view
!
   call write_message('Number of peaks: ',inum=numpeaks(pkind),pos=2)
!
   if (jscreen > 0) then
       call update_peak_list()
       call abilita_tasti('peaks',state=1)
       call vedinew(5)   !!!!,1,npunti)
   endif
!
   end subroutine update_peak_graph

! ---------------------------------------------------------------------

   subroutine search_peaks(iAction,statomin,statomax,search_value)
   USE VIEW
   USE General
   USE PatternRef
   USE peak_mod
   USE messagemod
   USE conteggi
   USE counts
!
   implicit none
   integer                                          :: iAction
   real                                             :: statomin,statomax
   real, dimension(5)                               :: search_value
   type(peak_type), dimension(:), allocatable, save :: pksav
   type(peaks_condition_type), save                 :: pkconds
   type(peaks_condition_type)                       :: pkcond_def
   real                                             :: scaln
   integer :: npeak
!
   select case (iAction)
      case (0)    ! Cancel (reset the conditions)
        pkcond = pkconds
        call peak_copy(pkind,pksav)
        call write_message('Number of peaks: ',inum=numpeaks(pkind),pos=2)
        call vedinew()

      case (1)    ! Open window, pass variables to graphic, save settings
        if (.not.allocated(pkindtot)) then  
            if (.not.allocated(pkind)) then ! Peak search has been not performed
                call run_peaksearch()
            else                            ! Peaks from external file: create only array pkindtot
                pkcond%srange = init_peak_range(theta_int(:,1),theta_int(:,2),alambda)
                call peak_create(theta_int(:,1),theta_int(:,2)-backgr(:),pksav,pkcond,pkindtot)
            endif
        endif
        pkconds = pkcond
        call peak_copy(pksav,pkind)
        statomin = thmin
        statomax = thmax
        if (pkcond%minp > 0) then
            search_value(1) = pkcond%minp
        else
            search_value(1) = thmin
        endif
        if (pkcond%maxp > 0) then
            search_value(2) = pkcond%maxp
        else
            search_value(2) = thmax
        endif
        search_value(3) = pkcond%amp
        search_value(4) = numpeaks(pkind)
        search_value(5) = numpeaks(pkindtot)

      case (2:6)   ! Performe new peak search
!
        if (iAction == 6) then ! Default required by user
            search_value(1) = max(pkcond_def%minp,thmin)
            search_value(2) = max(pkcond_def%maxp,thmax)
            search_value(3) = pkcond_def%amp
        endif
        pkcond%minp = search_value(1)
        pkcond%maxp = search_value(2)
        pkcond%amp = search_value(3)
        if (numpeaks(pkindtot) == 0) return

        select case (iAction)
          case (2,3,4,6)        ! range (2,3), threshold (4),  default(6)
            call peak_copy(pkind,pkindtot)
            call filtrasog(pkind,pkcond%amp/100,npeak,code=1)
            call peak_select(pkind,pkcond%minp,pkcond%maxp,DELETE_PEAK,outside=.true.)
            call peak_delete_selected(pkind)
            call peak_sort(pkind,ORD_BY_X)
!corr            if (numpeaks(pkind) > 0) call set_intensities(pkind,theta_int(:,7),theta_int(:,2),backgr)
            search_value(4) = numpeaks(pkind)   ! force update of num. of peaks
            call update_peak_graph()

          case (5)            ! number of peaks was changed
            pkcond%maxpk = int(search_value(4))
            if (pkcond%maxpk == numpeaks(pkind)) return
            pkcond%amp = 0  
!
!           Recover peaks and intensities for compute new amp (necessary also if maxpk < numpeaks)
            call peak_copy(pkind,pkindtot)
            call filtrasog(pkind,pkcond%amp/100,npeak,code=1)
            call peak_select(pkind,pkcond%minp,pkcond%maxp,DELETE_PEAK,outside=.true.)
            call peak_delete_selected(pkind)
!
!           Select nmaxpk peaks for intensities
            call peak_sort(pkind,-ORD_BY_Y)
            scaln = 100 / maxval(pkindtot%gety())             ! recompute scale on all peaks
            if (numpeaks(pkind) > pkcond%maxpk) then
                pkcond%amp = pkind(pkcond%maxpk+1)%gety()*scaln   ! define new threshold
                search_value(3) = pkcond%amp                 ! force update of num. of peaks
                call reallocate_peaks(pkind,pkcond%maxpk)
            else   ! too peaks required!
                pkcond%amp = pkind(numpeaks(pkind))%gety()*scaln   ! define new threshold
                search_value(3) = pkcond%amp        ! force update of amplitude
                search_value(4) = numpeaks(pkind)   ! force update of num. of peaks
            endif
            call peak_sort(pkind,ORD_BY_X)
!corr            if (numpeaks(pkind) > 0) call set_intensities(pkind,theta_int(:,7),theta_int(:,2),backgr)
            call update_peak_graph()
         
        end select

   end select

   end subroutine search_peaks

! ---------------------------------------------------------------------

   subroutine cell_dialog()
   USE PatternRef
   USE General
   USE Symmetry, only:nSpaceG
   USE enable_amb
   USE commandsmod
   USE comandiexpo, only:icomat
   USE strutil, only:cutst,remc0,addc0
   USE sinterface
   USE elements
   USE proginterface
   USE molcom, only: jscreen
   USE indexing
   USE spginfom
   USE unit_cell
!
   implicit none
   common/spaceindexing /ispaceindexing,fspaceindex(660),    &
                      ntotmult1,ntotmult2,percind(660),errespac(660),lauecell(660)
   integer :: ispaceindexing,ntotmult1,ntotmult2
   real    :: percind,errespac,fspaceindex
   character(len=20) :: lauecell
   common/iesext/iesext
   integer :: iesext
   common /ksearch/ ksearch
   integer :: ksearch
   common /definespac/iesspacesav,itrial,irunextra,nlin
   integer :: iesspacesav,itrial,irunextra,nlin
   common /spacegroup/iesspace,shiftzero
   integer :: iesspace
   real :: shiftzero
   common /centering/CellType,CellAxis,nruntre,iesdircell
   integer :: nruntre,iesdircell
   character CellType,CellAxis*3
   common /prova_kalpha/ kalphasav
   integer :: kalphasav
   integer, dimension(3) :: kshif
   real, dimension(6)    :: cellold
   character(len=18)     :: spacechar, spacecharold
   character(len=256)    :: contentC
   integer               :: ishif
   integer               :: kfindspace
   integer               :: kreturn
   character(len=:), allocatable  :: line
   type(element_type), dimension(:), allocatable :: elem,elemold
   integer :: ncell, i, icell, len_cont, ier, npq, iflagref
   type(spaceg_type) :: spgtemp
!
   call ClearMessage()
!
   kcount_status = 1  ! attiva info riflessi sulla statusbar
   call print_cell_list(cell_list,lo,'List of plausible cell parameters:')
   if (ifAutomatic == 1 .or. jscreen == 0) then
       icell = 1     ! select the first cell
       call viewrefcell(icell)  
   else
       call toolbar_set_state('continue'//char(0),0)
       call abilita_tasti('indexwin',0)
       call abilita_tasti('peaks',0)
       ncell = number_of_cells(cell_list)
       kexitrun = 0
       call open_cell_dialog(ncell, cell_list, icell)
       call abilita_tasti('indexwin',1)
       call abilita_tasti('peaks',1)
       if (kexitrun /= 0) return  ! exit from File > Exit !!!!FIXME - non funziona se fai Pattern > Indexing
   endif
!
!  Exit for 'cancel' (icell=0); %end with -nogui or -auto; index is last command with -nogui or -auto
   if (icell == 0 .or. ( (jscreen == 0 .or. ifAutomatic == 1) .and.   &
      (next_command_is(commands,icomat,'end') .or. (icomat == ncommands(commands))))) then
       !call abilita_tasti('pattern')
       !call abilita_tasti('peaks',1)   !!!add abilita index
       if (jscreen > 0) call toolbar_set_state('continue'//char(0),2)
!!! reset this variables to avoid problems in data1 for new run with ntreor
!!!FIXME - check is necessary also for ntreor after structure solution
       irunextra = 0
       iesspacesav = 1
       itrial = 1
       kexitrun = 2  ! force exit from loop in gescom
       return
   endif
   if (jscreen > 0) call toolbar_set_state('continue'//char(0),1)
   write(lo,'(//a)')'       The following cell has been selected: '
   call print_cell(cell_list(icell)%par,cell_list(icell)%sd,cell_list(icell)%sys,kpr=lo)
!
   ispaceindexing = -1
   ksearch = 0
   iesdircell = 1
   iesext = 0
   iesspace = 1
   iesspacesav = 1
!
!  Recupera il gruppo spaziale se è presente la direttiva space
   line = get_string_directive(commands,'space')
   kfindspace = 1   ! forza check sul gruppo spaziale
   if (len_trim(line) > 0) then
!
!      Check compatibility between spg in input file and new cell
       spgtemp = init_spaceg_type(line)
       if (csys_from_cell(cell) == spgtemp%csys_code) then
           call set_spaceg(line)  ! spacegr is now defined
           call yfrm02
           kfindspace = 0 
       endif
   endif
!
   spacechar = spaceg_string()
!
!  Salva i vecchi valori delle variabili
   cellold(1:6) = cell(1:6)
   spacecharold = spacechar
   call copy_elem(elemold,celem)
!
!  Apri la finestra per modificare cella,gruppo spaziale, contenuto
   spacechar = trim(spacechar) // char(0)
   contentC = trim(get_string_directive(commands,'cont')) !!!corr //char(0)    !find content in input file
   if (len_trim(contentC) == 0) call chemical_formula(celem,contentC) !extract from celem if content is not in input file
   contentC = trim(contentC)//char(0)   !!FIXME - chiedi a rosi se serve
   if (.not.(ifAutomatic == 1 .or. jscreen == 0)) then  !if auto or nogui jump this part
       len_cont = 256
       call cell_parameters_dlg(cell,kfindspace,spacechar,contentC,kreturn,len_cont)
       if (kreturn == 0) then
           kexitrun = 1
           return  ! exit required by user
       endif
   endif
   iesspace = kfindspace
   spacechar = remc0(spacechar)
   iesspacesav = iesspace
!
!  Convert string in new cell content
   call read_chemformula(remc0(contentC),ier,elem=elem)
   if (ier > 0 .or. numelem(elem) == 0) then
       kexitrun = 1
       return 
   else
       call elem_set_radiation(elem,neutro)
       call ordina_elements(elem,neutro)
   endif
!
!  update content if it has changed in type or number
   if (.not.equal_elements(elemold,elem)) then
       call copy_elem(celem,elem)
       call elem_to_nk(celem,.true.)
       call yfrm03(alambda,ier)
       call WriteContInfo(npq,ier)    !!!FIXME
   endif
!
!  cell has been changed ...
   if (any(abs(cellold(:) - cell(1:6)) > epsilon(1.0))) then   ! da migliorare
       call frm01( (/(cell(i),i=1,6),(0.0,i=7,13)/) )
       call gener(iflagref,1)
   endif
!
   if (iesspace == 0) then
!
!      Prendi il gruppo spaziale dell'utente
       spacegr = init_spaceg_type(line) ! set space group in structure spacegr
       read(spacechar(1:16),'(16a1)') nSpaceG
       call ti1983(nSpaceG)
       ishif = 0
       kshif(:) = 0
       call insym(ishif,kshif,ier)
       call xspinb()
       call yfrm02
       call WriteSymmInfo(lo)
       call yfl02
!
       ispaceindexing = 0
!
!corr-new
       call gener(iflagref,1)
       call datanew(POW_FILE,.true.,.true.,ier) ! rigenera i riflessi
       call export_file_exp()
   else
!             findspace+export del file nome1.exp
!             nota che findspace azzera isspace
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1  ! se ho dato peaksearch + findspace non rifaccio correzione kalpha
            kalphasav = 0
            if (kalpha.gt.0) then
                kalpha = 0
                kalphasav = 1
            endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1
           call datanew(POW_FILE,.true.,.true.,ier)
   endif
   if (kexitrun > 0) return
!
   kcount_status = 0
!
   return
   end subroutine cell_dialog

!-----------------------------------------------------------------------
   subroutine gener(iflagref,kpr)
   USE Riflessi
   USE General, only:ihmx,rhomin,rhomax,dtor,lo,cell,nrefl,knw,alambda
   USE Symmetry, only: kmat,tmat,nsym,icent,latt,jsys
   USE datamod, only: manage_filefc
   USE reflection_type_util, only:create_reflections, reflection_type
   USE sinterface
   USE counts, only: dvalue
   implicit none
   integer, intent(out) :: iflagref
   integer, intent(in)  :: kpr
   common/genob2/thmin,thmax,thstep
   common/atomi_au/natom_au,resoluz
   integer :: i,ier
   real :: thmin,thmax,thstep,resoluz
   integer :: natom_au
   type(reflection_type), dimension(:), allocatable :: refob
   integer                                          :: nrefob
!
   resoluz = dvalue(thmax)
   rhomax = 1. / (2*resoluz)**2
   rhomin = 1. / (2*dvalue(thmin))**2
!
   iflagref = 0
   call create_reflections(rhomin,rhomax,cell(:6),spaceg_string(),kmat,tmat,nsym,jsys,icent,latt,alambda,refob,nrefob,ihmx)
!
   call AllocaRiflessi(2)
   nrefl = nrefob
   call AllocaRiflessi(1)
   if (knw > 0) then
       call manage_filefc(refob,ier)
       if (ier /= 0) knw = 0
   endif
   do i=1,nrefl
      IndHKL(i,1:3) = refob(i)%hkl(:)
      IndHKL(i,4) = 1
      IndHKL(i,5) = refob(i)%phv
      SetFob(i,1) = 0.0
      SetFob(i,2) = 0.0
      SetFob(i,3) = 0.0
      SetFob(i,4) = 0.0001
      TThet (i)   = refob(i)%tthd
      Mult  (i)   = refob(i)%m
      WHM   (i)   = 0.0
         !write(6,*)'REF=',IndHKL(i,:3),TThet(i),mult(i)
   enddo
   if (knw > 0) fxsav(:) = refob(:nrefl)%fv   ! :nrefl because refob is not reallocated
   nrefl = nrefob  ! set global varible nrefl after AllocaRiflessi
!
   if (nrefl > 3000) iflagref = 1             ! segnala che ci sono + di 3000 riflessi
   if (kpr > 0) then
       write(lo, '(16x,"*",7x,"Generated reflections information",10x,"*")')
       write(lo, '(16x,"*",50x,"*")')
       write(lo, '(16x,"*",9x,"rho min         = ",f8.5,15x,"*")') rhomin
       write(lo, '(16x,"*",9x,"rho max         = ",f8.5,15x,"*")') rhomax
       write(lo, '(16x,"*",9x,"d (resolution)  = ",f8.5,15x,"*")') resoluz
       write(lo,'(16x,"*",9x,"reflections nr. = ",i8,15x, "*",/,16x,"*",9x,"h k l (max)     = ",3i4,11x,"*",/,16x,52("*"))') &
       nrefl,(ihmx(i),i=1,3)
   endif
   end subroutine gener

!-----------------------------------------------------------------------
      subroutine unpack (ind,ih,kk,il)
      implicit none
      integer, intent(in)  :: ind
      integer, intent(out) :: ih, kk, il
      integer              :: is
      ih = ind/262144
      is = ind - 262144*ih
      kk = is/512-256
      il = is-512*(kk+256)-256
      return
      end
! ----------------------------------------------------------------------
      real function rhof(p,jh,jk,jl)
      implicit none
      real, dimension(6), intent(in) :: p
      integer, intent(in)            :: jh,jk,jl
      real                           :: rho2
      rho2=p(1)*float(jh*jh)+p(2)*float(jk*jk)   &
       +p(3)*float(jl*jl)+p(4)*float(jh*jk)      &
       +p(5)*float(jh*jl)+p(6)*float(jk*jl)
      rhof=sqrt(rho2)
      end function rhof
!-----------------------------------------------------------------------
      real function ctheta(rho)
!
!-- compute 2-Theta value from ( sin(theta)/lambda ) ** 2
      USE General
      implicit none
      real, intent(in) :: rho
      real :: theta
      theta=sqrt(rho)*alambda
      if (theta.gt.1.) theta=1.
      theta=asin(theta)*rtod
      ctheta=2.0*theta
      return
      end
!-----------------------------------------------------------------------

   subroutine open_cell_list()
   USE General, only: POW_FILE, card
   USE commandsmod
   USE comandiexpo
   USE patternref, only: kexitrun
   USE indexing
   USE molcom, only: jscreen
   USE Conteggi, only: npunti
   USE variables
   implicit none
   integer :: iEnd, ier
   integer :: ip
!
   if (number_of_cells(cell_list) == 0) return
!
!  scarica in theta_int
   call dataset_to_thetaint(dataset)
!corr   call AllocaConteggi(2)
!corr   npunti = size_array(dataset%x)
!corr   call AllocaConteggi(1)
!corr   theta_int(:,1) = dataset%x
!corr   theta_int(:,2) = dataset%y
!corr   theta_int(:,7) = theta_int(:,1)
!corr   theta_int(:,3:6) = 0.0
!corr   thstep = dataset%tstep
!corr   thmin = dataset%tmin
!corr   thmax = dataset%tmax
   call ysfr37(npunti)  ! for extra
!
   call init_recycle()  ! init for extra in cell_dialog (find space g.) and gescom
   call cell_dialog()
   if (kexitrun > 0) return
!
   ip = command_position(commands,'data',back=.true.)
   call add_continue(commands,ip)
!
   call print_commands(commands,0)
   Messages(:) = ' ' ! reset all messagges for sub. scr2
   call create_expo_commands(commands,ipcom,icomq,card)
   icomat = ip
   ipdir = sum(commands(:ip)%ndir)
   if (jscreen > 0) call WaitCursorOn()
   call gescom(POW_FILE,iEnd,ier)
   if (jscreen > 0) call WaitCursorOff()
   end subroutine open_cell_list
