#include "mrconfig.h"
#include "forcomm1.h"
#include "forcomm2.h"
#include "callbacks.h"
#include "aliasx.h"

typedef char stringa20[20];

typedef struct {
      int   num;        // num. d'ordine del rifless
      int   hkl[3];     // h,k,l
      char  string[50]; // stringa con operatore e condizione
      float prob;       // probabilita' di estinzione
      int   ktype;      // singolo (1) o in sovrapposizione (> 1)
               } absref_type;
typedef struct {
      int num;
      char str1[10];
      char str2[60];
      float prob;
      char str3[12];
               } absref_dicomodo;

extern "C" void get_nabsref_(int *nabsref);
extern "C" void get_absref_(absref_type *nabsref);
extern "C" void selectednum_(int *num);
extern "C" void prendi_space_groups_(int *rowspace, int *numspace, int csdfreq[], stringa20 str[]);
extern "C" void run_indexing_(int *iCode);
extern "C" void run_peaksearchwin_();


/* internally used functions */

GtkWidget *xpm_checkbutton          (GtkWidget *parent,
                                     const gchar  *xpm_filename);
void       c_disegna_interval       (int *val, int kdraw);
/*
void       on_patt_check_toggled    (GtkToggleButton *togglebutton,
                                        gpointer         user_data);
void       on_patt_ok_clicked       (GtkButton       *button,
                                        gpointer         user_data);
void       on_patt_cancel_clicked   (GtkButton       *button,
                                        gpointer         user_data);
*/
//void       end_search_peaks         (GtkButton       *button,
//                                        gpointer         user_data);
void on_cancel_clicked(GtkButton *button, gpointer data);
void on_search_peaks(GtkWidget *button, gpointer data);
void       end_polynomial           (GtkButton       *button,
                                        gpointer         user_data);
void       get_interval_selection   (GtkWidget *widget, gpointer data);
void get_metrics(PangoFontDescription *font_desc, int *char_width, int *char_height);

extern "C" void cflush_(void);

GtkWidget* create_options_patt_dialog       ();
GtkWidget* create_Set_Search_Condition (float initsearch[]);
GtkWidget* create_polynomial (int coef,int n_int);

GtkWidget *spacegroup_dialog = NULL;
GtkWidget *complete_spacegroup_dlg = NULL;
GtkWidget *new_search = NULL;
GtkWidget *polynomial = NULL;
//GtkToggleButton *old_marker = NULL;
plot_option_type poption;

//corr static GtkWidget *combo2 = NULL;
static GtkWidget *spin_interval1;
static GtkWidget *spin_interval2;

static char *spacegroup[400];
static int n_spacegroup;
char string_space_select[60];
static int oldsel;
static int pos_int = 0;

static float limite_infth, limite_supth;
/*
static const char *patt_options_label[] = {"Plot Observed Profile",
                                     "Plot Computed Profile",
                                     "Plot Background",
                                     "Plot Difference Profile",
//                                     "Plot X Axis",
                                     "Mark Background Points",
                                     "Cumulative Chi Squared",
                                     "Mark Intervals",
                                     "Mark Reflections"
                                    };
const int nOPT = sizeof(patt_options_label)/sizeof(patt_options_label[0]);
static int statoglob[nOPT];
static const char *plot_type[] = {"Line",
                            "Scatter",
                            "Line + Symbol"};
*/

static const char *extin_labels[] = {" Extinction Group", "Fig.Mer"};
static int NEXTINLABELS = sizeof(extin_labels)/sizeof(extin_labels[0]);

static const char *spgr_labels[] = {" Space Group Name", " No. in CSD"};
static int NSPGRLABELS = sizeof(spgr_labels)/sizeof(spgr_labels[0]);

#ifdef OLDCELLDIALOG
static const char *space_labels[] = { " Nr. ", "a", "b", "c", "alpha", "beta", "gamma", "  Vol. ", 
                                      " FOMnew ", "M20", "shift", "NIX", "Extinction Group"};
static int NSPACELABELS = sizeof(space_labels)/sizeof(space_labels[0]);
#endif

int isens;
int rowspace,kpseudo,lstrout;
int extern active_amb;
stringa20 str_space;

float statomin, statomax;
static const int dimsearch = 5;
static float initsearch[dimsearch];
static float statosearch[dimsearch];
static float limite_inf;
static float limite_sup;
static int ultimo_intervallo;
int coef;
int val_interval=1;

extern plotok *cplotok;
extern int left_ruler;
extern int right_ruler;
extern int move_left_ruler;
extern int move_right_ruler;
extern char *fontn;
extern char *string_statusbar;
extern GtkWidget *finestre[6];
extern  char files_dir[256];

void combo_changed(GtkWidget *combo, GCallback cb, gpointer cb_data)
{
#ifndef GTK_COMBO_BOX
      g_signal_connect_after(G_OBJECT(GTK_COMBO(combo)->list), "select-child",
               cb, cb_data);
#else
      g_signal_connect_after(G_OBJECT(combo), "changed", cb, cb_data);
#endif
}

void open_tb_profile(GtkWidget *item, gpointer data)
{
//corr     mostra_tb(item, data);
     if (cplotok->kprofile == 0)
         cplotok->kprofile = -1;
     else
         cplotok->kprofile = 0;
}

void cancel_tb_profile (GtkWidget *item, GdkEventButton *event, gpointer data)
{
     cplotok->kprofile = 0;
//corr     cancel_tb(item, event, data);
}

/*corr
void apply_background(GtkWidget *item, gpointer data)
{

    fortran_al_lavoro();
    if (cplotok->iriet == 1)
        val_interval = 1;
    c_calcola_background(&val_interval);
    fine_lavoro();
}
*/

void ok_tb_background (GtkWidget *item, GdkEventButton *event, gpointer data)
{
    GtkWidget *main_window = gtk_widget_get_toplevel(item);
    val_interval = 200;
    c_disegna_interval(&val_interval,2);
    nascondi_tb(main_window);
}

void save_position_left ()
{
     if (left_ruler < limite_inf || cplotok->iact_interval == 1)
     {
         left_ruler = cc_nint(limite_inf);
         cplotok->theta_left[cplotok->iact_interval]=limite_infth;
     }
     else
     cplotok->theta_left[cplotok->iact_interval]=(left_ruler - cplotok->xdispC[0])/cplotok->xscaleC[0];

     spin_button_set_value(spin_interval1,cplotok->theta_left[cplotok->iact_interval]);
// la modifica del valore dello spin invoca la funzione change_ruler_left 
}

void save_position_right ()
{
     if (right_ruler > limite_sup || cplotok->iact_interval == ultimo_intervallo)
     {
         right_ruler = cc_nint(limite_sup);
         cplotok->theta_right[cplotok->iact_interval]=limite_supth;
     }
     else
     cplotok->theta_right[cplotok->iact_interval]=(right_ruler - cplotok->xdispC[0])/cplotok->xscaleC[0];

     spin_button_set_value(spin_interval2,cplotok->theta_right[cplotok->iact_interval]);
// la modifica del valore dello spin invoca la funzione change_ruler_right
}

static int oldPos = -1;

void get_interval_selection_with_bars (GtkWidget *widget, gpointer user_data)
{
     int pos;
//     static int nvolte;

     pos = pos_int-1;
     if(oldPos == pos)
         return;
     oldPos = pos;
     if(pos != -1)
     {
        cplotok->iact_interval = pos;
///        g_print("GET_INTERVAL pos = %d\n",pos);
        spin_button_set_value(spin_interval1,cplotok->theta_left[pos]);
        spin_button_set_value(spin_interval2,cplotok->theta_right[pos]);
        if (pos == 1)
        {
            gtk_widget_set_sensitive(spin_interval1,FALSE);
            gtk_widget_set_sensitive(spin_interval2,TRUE);
        }
        else if (pos == ultimo_intervallo)
        {
            gtk_widget_set_sensitive(spin_interval1,TRUE);
            gtk_widget_set_sensitive(spin_interval2,FALSE);
        }
        else
        {
            gtk_widget_set_sensitive(spin_interval1,TRUE);
            gtk_widget_set_sensitive(spin_interval2,TRUE);
        }
     }
}

void change_ruler_left(GtkWidget *spin, gpointer user_data)
{

   if(!move_left_ruler) /*operazioni inutili se modifico gli intervalli col mouse*/
   {
     cplotok->theta_left[cplotok->iact_interval] = (float) spin_button_get_value(spin);
     left_ruler = (int) (cplotok->theta_left[cplotok->iact_interval]*cplotok->xscaleC[0] + cplotok->xdispC[0]);
   }
   redrawpattern(2);
   cflush_();
   show_vertical_ruler(right_ruler);
   show_vertical_ruler(left_ruler);
}


void change_ruler_right(GtkWidget *spin, gpointer user_data)
{

   if(!move_right_ruler) //operazioni inutili se modifico gli intervalli col mouse
   {
     cplotok->theta_right[cplotok->iact_interval] = (float)spin_button_get_value(spin);
     right_ruler = (int) (cplotok->theta_right[cplotok->iact_interval]*cplotok->xscaleC[0] + cplotok->xdispC[0]);
   }
   redrawpattern(2);
   cflush_();
   show_vertical_ruler(right_ruler);
   show_vertical_ruler(left_ruler);
}

void action_interval(GtkWidget *button, gpointer data)
{
    int action = GPOINTER_TO_INT(data);
    switch (action)
    {
    case 1:            // Apply
         c_setintervals(&action);
         break;
    case 2:            // Ok
    case 3:            // Cancel
         cplotok->kruler = 0;
         c_setintervals(&action);
         gtk_widget_destroy(gtk_widget_get_toplevel(button));
         break;
    }
    val_interval = 200;
    c_disegna_interval(&val_interval,2);
}

void create_setintervals(int n_interval)
{
   const char *intervals[12];
   intervals[0] = g_strdup("Single Peak");
   for(int i=1; i<n_interval+1;i++)
       intervals[i] = g_strdup_printf("interval %2d",i);

   GtkWidget *dlg = gtk_dialog_new();
   gtk_window_set_title(GTK_WINDOW(dlg), "Intervals");
   
   GtkWidget *vbox = gtk_dialog_get_content_area(GTK_DIALOG(dlg));
   GtkWidget *frame = FRAME_BOLD("Modify the intervals", MyBLUE, 1.1f);
   gtk_container_add (GTK_CONTAINER (vbox), frame);
   gtk_container_set_border_width (GTK_CONTAINER (vbox), 10);
   GtkWidget *vbox1 =  vbox_new(FALSE, 10);
   gtk_container_set_border_width (GTK_CONTAINER (vbox1), 10);
   gtk_container_add (GTK_CONTAINER (frame), vbox1);

#ifdef IN_GTK3
   GtkWidget *align = new_alignment(GTK_ALIGN_CENTER, GTK_ALIGN_START, 0, 0);
#else
   GtkWidget *align = gtk_alignment_new(0.5, 0, 0, 0);
#endif
   gtk_box_pack_start (GTK_BOX (vbox1), align, FALSE, FALSE, 6);
   GtkWidget *comboint = create_combo(align, intervals, n_interval+1, 2, &pos_int);
   GtkWidget* hbox = hbox_new(FALSE, 10);
   gtk_container_set_border_width (GTK_CONTAINER (hbox), 10);
   gtk_widget_set_size_request(hbox,-1,90);
   gtk_box_pack_start (GTK_BOX (vbox1), hbox, FALSE, FALSE, 6);
   GtkWidget *label = gtk_label_new (" Two Theta min:");
   gtk_container_add (GTK_CONTAINER (hbox), label);

   spin_interval1 = spin_button_new_with_range(
        limite_infth, limite_supth, 0.05f);
   spin_button_set_value(spin_interval1, cplotok->theta_left[1]);
   gtk_container_add (GTK_CONTAINER (hbox), spin_interval1);
   set_width_chars(GTK_ENTRY(spin_interval1), 6);
   //gtk_widget_set_size_request(spin_interval1,70,20);
   gtk_widget_set_sensitive(spin_interval1,FALSE);

   label = gtk_label_new (" Two Theta max:");
   gtk_container_add (GTK_CONTAINER (hbox), label);
   spin_interval2 = spin_button_new_with_range(
        limite_infth, limite_supth, 0.05f);
//corr
   cplotok->iact_interval = 1;
//corr
   spin_button_set_value(spin_interval2, cplotok->theta_right[1]);
   gtk_container_add (GTK_CONTAINER (hbox), spin_interval2);
   //gtk_widget_set_size_request(spin_interval2,70,20);
   set_width_chars(GTK_ENTRY(spin_interval2), 6);
   
   combo_changed(comboint, G_CALLBACK(get_interval_selection_with_bars), NULL);
   g_signal_connect(G_OBJECT(spin_interval1), "value-changed",
       G_CALLBACK(change_ruler_left), GINT_TO_POINTER(1));
   g_signal_connect(G_OBJECT(spin_interval2), "value-changed",
       G_CALLBACK(change_ruler_right), GINT_TO_POINTER(2));

   GtkWidget *button = APPLY_button();
   g_signal_connect(G_OBJECT(button), "clicked",
       G_CALLBACK(action_interval), GINT_TO_POINTER(1));
   gtk_dialog_add_action_widget (GTK_DIALOG (dlg), button, 1);
   button = OK_button();
   g_signal_connect(G_OBJECT(button), "clicked",
       G_CALLBACK(action_interval), GINT_TO_POINTER(2));
   gtk_dialog_add_action_widget (GTK_DIALOG (dlg), button, 2);
   button = CANCEL_button();
   g_signal_connect(G_OBJECT(button), "clicked",
       G_CALLBACK(action_interval), GINT_TO_POINTER(3));
   gtk_dialog_add_action_widget (GTK_DIALOG (dlg), button, 3);
   g_signal_connect_swapped(G_OBJECT(dlg), "delete_event",
       G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
   gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
         GTK_BUTTONBOX_SPREAD);
   gtk_widget_show_all(dlg);
}

void open_tb_intervals(GtkWidget *item, gpointer data)
{
     int n_interval = -1;

// forza la modalita' selezione
     gpointer button_sel = get_object(finestre[0], "selectionmode");
     obj_set_active(button_sel, TRUE);

     cplotok->kruler = 1;
     c_setintervals(&n_interval);
//
//   Definisci limiti inferiori e superiori in 2-theta e pixel
//
     limite_infth = cplotok->theta_left[1];
     limite_supth = cplotok->theta_right[n_interval];
     limite_inf = limite_infth*cplotok->xscaleC[0] + cplotok->xdispC[0];
     limite_sup = limite_supth*cplotok->xscaleC[0] + cplotok->xdispC[0];
//
//   Disegna rulers
//
     redrawpattern(1);
     int limite_sup1 = (int)(cplotok->theta_right[1]*cplotok->xscaleC[0] + cplotok->xdispC[0]);
     left_ruler = (int)limite_inf;
     right_ruler = limite_sup1;
     show_vertical_ruler(left_ruler);
     show_vertical_ruler(right_ruler);

     ultimo_intervallo = n_interval;

     create_setintervals(n_interval);
}

void action_range(GtkWidget *button, gpointer data)
{
    int action = GPOINTER_TO_INT(data);
    switch (action)
    {
    case 1:            // Apply
         c_set_range(&action);
         break;
    case 2:            // Ok
    case 3:            // Cancel
         cplotok->kruler = 0;
         c_set_range(&action);
         gtk_widget_destroy(gtk_widget_get_toplevel(button));
//corr         finestra_modale_chiusa2();
         break;
    }
}

void create_setrange()
{
   GtkWidget *dlg = gtk_dialog_new();
   gtk_window_set_title(GTK_WINDOW(dlg), "Range");
   
   GtkWidget *vbox = gtk_dialog_get_content_area(GTK_DIALOG(dlg));
   GtkWidget *frame = FRAME_BOLD("Set range", MyBLUE, 1.1f);
   gtk_container_add (GTK_CONTAINER (vbox), frame);
   gtk_container_set_border_width (GTK_CONTAINER (vbox), 10);
   GtkWidget* hbox = hbox_new(FALSE, 10);
   gtk_container_set_border_width (GTK_CONTAINER (hbox), 10);
   gtk_widget_set_size_request(hbox,-1,90);
   gtk_container_add (GTK_CONTAINER (frame), hbox);
   GtkWidget *label_range1 = gtk_label_new (" Two Theta min:");
   gtk_container_add (GTK_CONTAINER (hbox), label_range1);

   spin_interval1 = spin_button_new_with_range(
        limite_infth, limite_supth, 0.05f);
   spin_button_set_value(spin_interval1, cplotok->theta_left[0]);
   gtk_container_add (GTK_CONTAINER (hbox), spin_interval1);
   //gtk_widget_set_size_request(spin_interval1,70,20);
   set_width_chars(GTK_ENTRY(spin_interval1), 6);

   GtkWidget *label_range2 = gtk_label_new (" Two Theta max:");
   gtk_container_add (GTK_CONTAINER (hbox), label_range2);
   spin_interval2 = spin_button_new_with_range(
        limite_infth, limite_supth, 0.05f);
   spin_button_set_value(spin_interval2, cplotok->theta_right[0]);
   gtk_container_add (GTK_CONTAINER (hbox), spin_interval2);
   //gtk_widget_set_size_request(spin_interval2,70,20);
   set_width_chars(GTK_ENTRY(spin_interval2), 6);
   g_signal_connect(G_OBJECT(spin_interval1), "value-changed",
       G_CALLBACK(change_ruler_left), GINT_TO_POINTER(1));
   g_signal_connect(G_OBJECT(spin_interval2), "value-changed",
       G_CALLBACK(change_ruler_right), GINT_TO_POINTER(2));
   
   GtkWidget *button = APPLY_button();
   g_signal_connect(G_OBJECT(button), "clicked",
       G_CALLBACK(action_range), GINT_TO_POINTER(1));
   gtk_dialog_add_action_widget (GTK_DIALOG (dlg), button, 1);
   button = OK_button();
   g_signal_connect(G_OBJECT(button), "clicked",
       G_CALLBACK(action_range), GINT_TO_POINTER(2));
   gtk_dialog_add_action_widget (GTK_DIALOG (dlg), button, 2);
   button = CANCEL_button();
   g_signal_connect(G_OBJECT(button), "clicked",
       G_CALLBACK(action_range), GINT_TO_POINTER(3));
   gtk_dialog_add_action_widget (GTK_DIALOG (dlg), button, 3);
   g_signal_connect_swapped(G_OBJECT(dlg), "delete_event",
       G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
//corr   finestra_modale_aperta2(dlg);
   gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
         GTK_BUTTONBOX_SPREAD);
   gtk_widget_show_all(dlg);
}

void open_tb_range(GtkWidget *item, gpointer data)
{
     int iact = 0;

// forza la modalita' selezione
     gpointer button_sel = get_object(finestre[0], "selectionmode");
     obj_set_active(button_sel, TRUE);

     cplotok->kruler = 1;
     cplotok->iact_interval = 0;
     ultimo_intervallo = 100;

     c_set_range(&iact);
//
//   Definisci limiti inferiori e superiori in 2-theta e pixel
//
     limite_infth = cplotok->theta_left[0];
     limite_supth = cplotok->theta_right[0];
     limite_inf = limite_infth*cplotok->xscaleC[0] + cplotok->xdispC[0];
     limite_sup = limite_supth*cplotok->xscaleC[0] + cplotok->xdispC[0];
//
//   Disegna rulers
//
     redrawpattern(1);
     left_ruler = (int)limite_inf;
     right_ruler = (int)limite_sup;
     show_vertical_ruler(left_ruler);
     show_vertical_ruler(right_ruler);

     create_setrange();
}

//void open_new_search(GtkWidget *item, char *string, guint cod)

void Set_Defaults_Search_Condition(GtkWidget *but, gpointer data)
{
     int iact=6;
     c_search_peaks(&iact,&statomin,&statomax,initsearch);
     for (int i=0; i<dimsearch; i++)
         statosearch[i] = initsearch[i];
     GtkWidget *dlg = gtk_widget_get_toplevel(but);

     GtkWidget *label = get_widget(dlg, "spinbutton1");
     int hnd = get_int(label, "hnd");
     g_signal_handler_block(G_OBJECT(label), hnd);
     spin_button_set_value(label, statosearch[0]);
     g_signal_handler_unblock(G_OBJECT(label), hnd);

     label = get_widget(dlg, "spinbutton2");
     hnd = get_int(label, "hnd");
     g_signal_handler_block(G_OBJECT(label), hnd);
     spin_button_set_value(label, statosearch[1]);
     g_signal_handler_unblock(G_OBJECT(label), hnd);
  
     label = get_widget(dlg, "spinbutton3");
     hnd = get_int(label, "hnd");
     g_signal_handler_block(G_OBJECT(label), hnd);
     spin_button_set_value(label, statosearch[2]);
     g_signal_handler_unblock(G_OBJECT(label), hnd);
  
     label = get_widget(dlg, "spinbutton4");
     hnd = get_int(label, "hnd");
     g_signal_handler_block(G_OBJECT(label), hnd);
     spin_button_set_value(label, statosearch[3]);
     g_signal_handler_unblock(G_OBJECT(label), hnd);
}

void open_new_search(gpointer item, gpointer data)
{
     int iact=1;
     int i;

     c_search_peaks(&iact,&statomin,&statomax,initsearch);
     for (i=0; i<dimsearch; i++)
         statosearch[i] = initsearch[i];
     new_search = create_Set_Search_Condition(initsearch);
     gtk_widget_show(new_search);
     gdk_window_raise(gtk_widget_get_window(new_search));
     finestra_modale_aperta2(new_search);
}

void peak_search(gpointer item, gpointer data)
{
     run_peaksearchwin_();
     if(get_widget(finestre[0], "peak_list_win") != NULL)
        peak_list(NULL, NULL);
}

void end_Set_Search_Condition  (GtkButton *button, gpointer data)
{
     int iact = GPOINTER_TO_INT(data);
     gtk_widget_destroy (gtk_widget_get_toplevel(GTK_WIDGET(button)));
     finestra_modale_chiusa2();
     if(iact == 0)
        c_search_peaks(&iact,&statomin,&statomax,statosearch);
}

GtkWidget*
create_Set_Search_Condition (float initsearch[])
{
  GtkWidget *window1;
  GtkWidget *vbox1;
  GtkWidget *table1;
  GtkWidget *label1;
  GtkWidget *label3;
  GtkWidget *label4;
  GtkWidget *label2;
  GObject *spinbutton1_adj;
  GtkWidget *spinbutton1;
  GObject *spinbutton2_adj;
  GtkWidget *spinbutton2;
  GObject *spinbutton3_adj;
  GtkWidget *spinbutton3;
  GObject *spinbutton4_adj;
  GtkWidget *spinbutton4;
  GtkWidget *search_ok;
  GtkWidget *search_cancel;
  GtkWidget *search_def;

  window1 = gtk_dialog_new ();
  g_object_set_data (G_OBJECT (window1), "window1", window1);
  gtk_window_set_title (GTK_WINDOW (window1), "Set Search Conditions");
  gtk_window_set_transient_for(GTK_WINDOW(window1), GTK_WINDOW(finestre[0]));
  gtk_window_set_position(GTK_WINDOW(window1), GTK_WIN_POS_CENTER_ON_PARENT);

  vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(window1));
  g_object_set_data (G_OBJECT (window1), "vbox1", vbox1);
  gtk_widget_show (vbox1);

  table1 = table_new (4, 2, FALSE);
  g_object_set_data (G_OBJECT (window1), "table1", table1);
  gtk_widget_show (table1);
  gtk_container_add (GTK_CONTAINER (vbox1), table1);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 30);
  table_set_row_spacings (table1, 20);
  table_set_col_spacings (table1, 10);

  label1 = gtk_label_new ("Minimum 2-theta: ");
  g_object_set_data (G_OBJECT (window1), "label1", label1);
  gtk_widget_show (label1);
  table_attach_exp (table1, label1, 0, 1, 0, 1);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_RIGHT);
  set_alignment (label1, 1, 0.5);

  label3 = gtk_label_new ("% Int. Threshold:");
  g_object_set_data (G_OBJECT (window1), "label3", label3);
  gtk_widget_show (label3);
  table_attach_exp (table1, label3, 0, 1, 2, 3);
  gtk_label_set_justify (GTK_LABEL (label3), GTK_JUSTIFY_RIGHT);
  set_alignment (label3, 1, 0.5);

  label4 = gtk_label_new ("Number of Peaks:");
  g_object_set_data (G_OBJECT (window1), "label4", label4);
  gtk_widget_show (label4);
  table_attach_exp (table1, label4, 0, 1, 3, 4);
  set_alignment (label4, 1, 0.5);

  label2 = gtk_label_new ("Maximum 2-theta:");
  g_object_set_data (G_OBJECT (window1), "label2", label2);
  gtk_widget_show (label2);
  table_attach_exp (table1, label2, 0, 1, 1, 2);
  gtk_label_set_justify (GTK_LABEL (label2), GTK_JUSTIFY_RIGHT);
  set_alignment (label2, 1, 0.5);

  spinbutton1_adj = adj_new (initsearch[0], statomin, statomax, 1, 10);
  spinbutton1 = spin_button_new (GTK_ADJUSTMENT (spinbutton1_adj), 1, 2);
  g_object_set_data (G_OBJECT (window1), "spinbutton1", spinbutton1);
  gtk_widget_show (spinbutton1);
  table_attach_exp (table1, spinbutton1, 1, 2, 0, 1);
  gtk_entry_set_width_chars(GTK_ENTRY(spinbutton1), 7);
  spin_button_set_numeric(spinbutton1,TRUE);
  int hnd = g_signal_connect(G_OBJECT(spinbutton1), "value-changed",
           G_CALLBACK(on_search_peaks), GINT_TO_POINTER(2));
  g_object_set_data (G_OBJECT (spinbutton1), "hnd", GINT_TO_POINTER(hnd));

  spinbutton2_adj = adj_new (initsearch[1], statomin, statomax, 1, 10);
  spinbutton2 = spin_button_new (GTK_ADJUSTMENT (spinbutton2_adj), 1, 2);
  g_object_set_data (G_OBJECT (window1), "spinbutton2", spinbutton2);
  gtk_widget_show (spinbutton2);
  table_attach_exp (table1, spinbutton2, 1, 2, 1, 2);
  gtk_entry_set_width_chars(GTK_ENTRY(spinbutton2), 7);
  spin_button_set_numeric(spinbutton2,TRUE);
  hnd = g_signal_connect(G_OBJECT(spinbutton2), "value-changed",
           G_CALLBACK(on_search_peaks), GINT_TO_POINTER(3));
  g_object_set_data (G_OBJECT (spinbutton2), "hnd", GINT_TO_POINTER(hnd));

  spinbutton3_adj = adj_new (initsearch[2], 0, 99, 0.2, 10);
  spinbutton3 = spin_button_new (GTK_ADJUSTMENT (spinbutton3_adj), 1, 2);
  g_object_set_data (G_OBJECT (window1), "spinbutton3", spinbutton3);
  gtk_widget_show (spinbutton3);
  table_attach_exp (table1, spinbutton3, 1, 2, 2, 3);
  gtk_entry_set_width_chars(GTK_ENTRY(spinbutton3), 7);
  spin_button_set_numeric(spinbutton3,TRUE);
  hnd = g_signal_connect(G_OBJECT(spinbutton3), "value-changed",
           G_CALLBACK(on_search_peaks), GINT_TO_POINTER(4));
  g_object_set_data (G_OBJECT (spinbutton3), "hnd", GINT_TO_POINTER(hnd));

  spinbutton4_adj = adj_new (initsearch[3], 0, initsearch[4], 1, 10);
  spinbutton4 = spin_button_new (GTK_ADJUSTMENT (spinbutton4_adj), 1, 0);
  g_object_set_data (G_OBJECT (window1), "spinbutton4", spinbutton4);
  gtk_widget_show (spinbutton4);
  table_attach_exp (table1, spinbutton4, 1, 2, 3, 4);
  gtk_entry_set_width_chars(GTK_ENTRY(spinbutton4), 7);
  spin_button_set_numeric(spinbutton4,TRUE);
  hnd = g_signal_connect(G_OBJECT(spinbutton4), "value-changed",
           G_CALLBACK(on_search_peaks), GINT_TO_POINTER(5));
  g_object_set_data (G_OBJECT (spinbutton4), "hnd", GINT_TO_POINTER(hnd));

  search_ok = OK_button();
  g_object_set_data (G_OBJECT (window1), "search_ok", search_ok);
  gtk_widget_show (search_ok);
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), search_ok, 1);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(search_ok)),
         GTK_BUTTONBOX_SPREAD);
  g_signal_connect (G_OBJECT (search_ok), "clicked",
                      G_CALLBACK (end_Set_Search_Condition),
                      GINT_TO_POINTER(1));

  search_def = DEFAULTS_button();
  g_object_set_data (G_OBJECT (window1), "search_def", search_def);
  gtk_widget_show (search_def);
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), search_def, 3);
  g_signal_connect (G_OBJECT (search_def), "clicked",
                      G_CALLBACK (Set_Defaults_Search_Condition),
                      (gpointer) window1);

  search_cancel = CANCEL_button();
  g_object_set_data (G_OBJECT (window1), "search_cancel", search_cancel);
  gtk_widget_show (search_cancel);
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), search_cancel, 2);

  g_signal_connect (G_OBJECT (search_cancel), "clicked",
                      G_CALLBACK (end_Set_Search_Condition),
                      GINT_TO_POINTER(0));

  g_signal_connect_swapped(G_OBJECT(window1), "delete_event",
       G_CALLBACK(gtk_button_clicked), G_OBJECT(search_cancel));
  g_signal_connect (G_OBJECT (window1), "delete_event",
                      G_CALLBACK(true_cb), NULL);

  return window1;
}

void open_polynomial(GtkWidget *item, gpointer data)
{
     int iact=1;
     int n_interval;

     val_interval = 1;
     c_salva_background(&iact, &n_interval);
     c_disegna_interval(&val_interval,2);

     c_polynomial(&iact, &coef, &val_interval);
     polynomial = create_polynomial(coef, n_interval);
     gtk_widget_show(polynomial);
     gdk_window_raise(gtk_widget_get_window(polynomial));
     finestra_modale_aperta2(polynomial);
}

GtkWidget* create_polynomial (int coef, int n_interval)
{
  GtkWidget *window1;
  GtkWidget *vbox1;
//corr  GtkWidget *hbox1;
  GtkWidget *label1;
  GtkWidget *spinbutton;
  GtkWidget *hbox2;
  GtkWidget *poly_ok;
  GtkWidget *poly_cancel;

  window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  g_object_set_data (G_OBJECT (window1), "window1", window1);
  gtk_container_set_border_width (GTK_CONTAINER (window1), 10);
  gtk_window_set_title (GTK_WINDOW (window1), "Polynomial Coefficients");

  vbox1 = vbox_new (FALSE, 0);
  g_object_set_data (G_OBJECT (window1), "vbox1", vbox1);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (window1), vbox1);

  GtkWidget *table = table_new(2, 2, FALSE);
  gtk_widget_show (table);
  gtk_box_pack_start (GTK_BOX (vbox1), table, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (table), 20);
  table_set_row_spacings (table, 20);
  table_set_col_spacings (table, 10);

  label1 = gtk_label_new ("Number of Coefficients:");
  g_object_set_data (G_OBJECT (window1), "label1", label1);
  set_alignment(label1, 0, 0.5f);
  gtk_widget_show (label1);
  table_attach_exp(table, label1, 0, 1, 0, 1);

  spinbutton = SPIN_NEW (1, 11, coef, 1, 0);
  g_object_set_data (G_OBJECT (window1), "spinbutton", spinbutton);
  gtk_widget_show (spinbutton);
  table_attach_exp(table, spinbutton, 1, 2, 0, 1);
  gtk_entry_set_width_chars(GTK_ENTRY(spinbutton), 4);
  spin_button_set_numeric(spinbutton,TRUE);

  label1 = gtk_label_new ("Select interval:");
  gtk_widget_show (label1);
  set_alignment(label1, 0, 0.5f);
  table_attach_exp(table, label1, 0, 1, 1, 2);

  const char *intervals[12];
  for(int i=0; i<n_interval+1;i++)
      intervals[i] = g_strdup_printf("interval %2d",i+1);

  GtkWidget *combo2 = create_combo(NULL, intervals, n_interval, val_interval, &val_interval, NULL, false);
  gtk_widget_show_all(get_widget(combo2, "parent"));
  g_object_set_data(G_OBJECT(window1),"intervals",get_widget(combo2, "entry"));
  combo_changed(combo2, G_CALLBACK(get_interval_selection), NULL);
  table_attach_exp(table, get_widget(combo2, "parent"), 1, 2, 1, 2);

  hbox2 = hbutton_box_new();
  g_object_set_data (G_OBJECT (window1), "hbox2", hbox2);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox2, FALSE, FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (hbox2), 10);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(hbox2), GTK_BUTTONBOX_SPREAD);

  poly_ok = OK_button();
  g_object_set_data (G_OBJECT (window1), "poly_ok", poly_ok);
  gtk_widget_show (poly_ok);
  gtk_container_add (GTK_CONTAINER (hbox2), poly_ok);

  poly_cancel = CANCEL_button();
  g_object_set_data (G_OBJECT (window1), "poly_cancel", poly_cancel);
  gtk_widget_show (poly_cancel);
  gtk_container_add (GTK_CONTAINER (hbox2), poly_cancel);

  g_signal_connect (G_OBJECT (poly_cancel), "clicked",
                      G_CALLBACK (on_cancel_clicked),
                      NULL);
  g_signal_connect(G_OBJECT(poly_ok), "clicked", G_CALLBACK(end_polynomial),
                     GINT_TO_POINTER(1));

  return window1;
}

//   callbacks


void on_cancel_clicked  (GtkButton *button, gpointer data)
{
//corr    int iact = 2;
//corr    int n_interval;

//corr    c_salva_background(&iact,&n_interval);
    gtk_widget_destroy (gtk_widget_get_toplevel(GTK_WIDGET(button)));
    finestra_modale_chiusa2();
}

void on_search_peaks(GtkWidget *button, gpointer data)
{
   GtkWidget *dlg = gtk_widget_get_toplevel(button);
   int iact = GPOINTER_TO_INT(data);
   GtkWidget *label = get_widget(dlg, "spinbutton1");
   statosearch[0] = (float)spin_button_get_value(label);

   label = get_widget(dlg, "spinbutton2");
   statosearch[1] = (float)spin_button_get_value(label);

   label = get_widget(dlg, "spinbutton3");
   statosearch[2] = (float)spin_button_get_value(label);

   label = get_widget(dlg, "spinbutton4");
   statosearch[3] = (float)spin_button_get_value(label);
   fortran_al_lavoro();
   c_search_peaks(&iact,&statomin,&statomax,statosearch);
   fine_lavoro();
   if((iact >= 2) && (iact <= 4))
   {
      label = get_widget(dlg, "spinbutton4");
      int hnd = get_int(label, "hnd");
      g_signal_handler_block(G_OBJECT(label), hnd);
      spin_button_set_value(label, statosearch[3]);
      g_signal_handler_unblock(G_OBJECT(label), hnd);
   }
   else if(iact == 5)
   {
      label = get_widget(dlg, "spinbutton3");
      int hnd = get_int(label, "hnd");
      g_signal_handler_block(G_OBJECT(label), hnd);
      spin_button_set_value(label, statosearch[2]);
      g_signal_handler_unblock(G_OBJECT(label), hnd);
   }
}

void end_polynomial (GtkButton *button, gpointer user_data)
{
   int iact=2;
   GtkWidget *label;

   label = get_widget(polynomial, "spinbutton");
   coef = spin_button_get_value_as_int(label);

   gtk_widget_destroy (gtk_widget_get_toplevel(GTK_WIDGET(button)));
   finestra_modale_chiusa2();

   fortran_al_lavoro();
   c_polynomial(&iact,&coef,&val_interval);
   fine_lavoro();
}

void get_interval_selection (GtkWidget *widget, gpointer data)
{
//     g_print("GET_COMBOSELECTION: %d\n", *val_interval);
   int iact = 1;
   c_disegna_interval(&val_interval,2);
   c_polynomial(&iact, &coef, &val_interval);
   GtkWidget *dlg = gtk_widget_get_toplevel(widget);
   GtkWidget *spin = get_widget(dlg, "spinbutton");
   spin_button_set_value(spin, coef);
}

#ifdef OLDCELLDIALOG
void sel_to_cell (GtkTreeSelection *selec, gpointer data)
{
  int num;
  rowspace = row_selected(selec);

  if(rowspace != -1)
  {
     num = rowspace+1;
     viewrefcell_(&num);
  }

}
#endif

void exit_spacedialog(GtkButton *button, gpointer user_data)
{
//mr  int ier;
//corrado
//  gtk_widget_set_sensitive(spacegroup_dialog,FALSE);
//  ier = cMsgWinErr("WARNING", "Do you want stop the run?",
//                    QUEST_WINDOW_YES_NO);
//  if (ier == 1)
//  {
     gtk_widget_destroy(spacegroup_dialog);
     cplotok->kexitrun = 2;
     gtk_main_quit();
//  }
//  else
//     gtk_widget_set_sensitive(spacegroup_dialog,TRUE);
}

#ifdef OLDCELLDIALOG
void end_celldialog(GtkButton *button, gpointer user_data)
{
  gtk_main_quit();
  gtk_widget_destroy(gtk_widget_get_toplevel(GTK_WIDGET(button)));
}
#endif

void ok_spacedialog(GtkButton *button, gpointer user_data)
{
  GtkWidget *but, *entry;
  int ier;

  but = get_widget(spacegroup_dialog, "spacebutton");
  if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(but)))  /* checkbutton attivo: prendo il gr. spaziale dall' entry */
  {
    entry = get_widget(spacegroup_dialog, "entry_spacegroup");
    ScriviStringa(string_space_select, sizeof(string_space_select),"%s", gtk_editable_get_chars(GTK_EDITABLE(entry), 0, -1));
//    g_print("gruppo spaziale = %s\n",string_space_select);
    gtk_widget_destroy(spacegroup_dialog);
    gtk_main_quit();
  }
  else                    /* checkbutton non attivo: prendo gruppo spaziale dalla lista */
  {
    if (rowspace == -1)   /* nessuna selezione sulla lista */
    {
         gtk_widget_set_sensitive(spacegroup_dialog,FALSE);
         ier = cMsgWinErr("WARNING", " Select space group! ",WARN_WINDOW);
         if (ier == 1) gtk_widget_set_sensitive(spacegroup_dialog,TRUE);
    }
    else
    {
         ScriviStringa(string_space_select,sizeof(string_space_select),"%10s",str_space);
         gtk_widget_destroy(spacegroup_dialog);
         gtk_main_quit();
    }
  }
}

void  c_prendi_space_groups(int rowspace, int *numspace, int csdfreq[],
                            stringa20 strspace[])
{
      prendi_space_groups_(&rowspace, numspace, csdfreq, strspace);
}

void sel_to_extinction (GtkTreeSelection *selec, gpointer data)
{
   GtkWidget *framel, *framez, *listaspace, *listaext;
   int isel;
   int numspace;
   int i, row;
   int select;
//   const gchar *rowstring[16];
   char stringa[20];
   int csdfreq[20];
   stringa20 strspace[20];
   char **rowstring = g_new0(char *, NSPGRLABELS);

   for (i=0;i<NSPGRLABELS;i++)
       rowstring[i] = g_new0(char, 40);


   row = row_selected(selec);
   if(row != -1)
      isel = GPOINTER_TO_INT(data);
   else
      isel = 0;
   framel = get_widget(spacegroup_dialog, "frame_space");
   framez = get_widget(spacegroup_dialog, "frame_zoom");
   listaspace = get_widget(spacegroup_dialog, "spacelista");
   rowspace = -1;
   if (isel)       /* selezione attiva sulla lista dei gruppi di estinzione */
   {
       if (oldsel != isel && oldsel != 0) /*disattiva selezione sull' altra lista con pseudo*/
       {
           ScriviStringa(stringa,sizeof(stringa),"extinctionlista%d",oldsel);
           listaext = get_widget(spacegroup_dialog, stringa);
           unselect_all(GTK_TREE_VIEW(listaext));
       }
       gtk_widget_set_sensitive(framel, TRUE);
       gtk_widget_set_sensitive(framez, TRUE);
       select = kpseudo*(row-1+isel)+row+1;
       c_prendi_space_groups(select,&numspace, csdfreq, strspace);
       clear_list(listaspace);
       for (i=0;i<numspace;i++)
       {
            ScriviStringa(rowstring[0], 40, "%s", strspace[i]);
            ScriviStringa(rowstring[1], 40, "%d (%.2f %%)", csdfreq[i], (float) csdfreq[i]*100./465883.);
            add_line_to_listM(listaspace,  rowstring);
//          rowstring[i] = It[i];
       }
//       updclistavec(listaspace, rowstring, numspace, 1);
//NEW
       if(numspace == 1)
          select_row(listaspace, 0);
   }
   else            /* selezione disattivata */
   {
       gtk_widget_set_sensitive(framel, FALSE);
       gtk_widget_set_sensitive(framez, FALSE);
       clear_list(listaspace);
   }
   oldsel = isel;
}

void sel_to_spacegroup (GtkTreeSelection *selec, GtkWidget *list)
{
       rowspace = row_selected(selec);
       if(rowspace != -1)
          ScriviStringa(str_space, 20, get_selected_row_col(list, 0));
}
void selection_user(GtkWidget *widget, gpointer data)
{
   GtkWidget *combo, *framext;
   GtkWidget *listaext;

   combo = get_widget(spacegroup_dialog, "combo_space_user");
   framext = get_widget(spacegroup_dialog, "frame_extinction");
   if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)))
   {
       gtk_widget_set_sensitive(combo, TRUE);
       gtk_widget_set_sensitive(framext, FALSE);
       listaext = get_widget(spacegroup_dialog, "extinctionlista1");
       if(listaext != NULL)
          unselect_all(GTK_TREE_VIEW(listaext));
       listaext = get_widget(spacegroup_dialog, "extinctionlista2");
       if(listaext != NULL)
          unselect_all(GTK_TREE_VIEW(listaext));
   }
   else
   {
       gtk_widget_set_sensitive(combo, FALSE);
       gtk_widget_set_sensitive(framext, TRUE);
   }
}

void scelta_riga(GtkTreeSelection  *sele, gpointer data)
{
     GtkTreeView *tree_view;

     tree_view = gtk_tree_selection_get_tree_view(sele);
     GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(tree_view));
     GtkTreeIter iter;
     if(gtk_tree_selection_get_selected(sele, &model, &iter))
     {
          int num;
          gtk_tree_model_get (model, &iter, 0, &num, -1);
          selectednum_(&num);
     }
}

void RiempiLista(GtkListStore *list_store, int nabsref, std::vector<absref_dicomodo> absref)
{
  GtkTreeIter iter;
  gtk_list_store_clear(list_store);
  for(int i=0; i<nabsref; i++)
  {
      gtk_list_store_append (list_store, &iter);
      gtk_list_store_set (list_store, &iter, 0, absref[i].num,
           1, absref[i].str1, 2, absref[i].str2, 3, absref[i].prob,
           4, absref[i].str3, -1);
  }
}

bool Alphagreater(char *str1, char *str2)
{
   gchar *temp1, *temp2;
   temp1 = g_utf8_casefold(str1, -1);
   temp2 = g_utf8_casefold(str2, -1);
   int result = strcmp(temp1, temp2);
   g_free(temp1); 
   g_free(temp2); 
   return (result < 0);
}

bool sort_by_numd( absref_dicomodo elem1, absref_dicomodo elem2 )
{
   return (elem1.num > elem2.num);
}
bool sort_by_num ( absref_dicomodo elem1, absref_dicomodo elem2 )
{
   return (elem1.num < elem2.num);
}

bool sort_by_probd( absref_dicomodo elem1, absref_dicomodo elem2 )
{
   return (elem1.prob > elem2.prob);
}
bool sort_by_prob ( absref_dicomodo elem1, absref_dicomodo elem2 )
{
   return (elem1.prob < elem2.prob);
}

bool sort_by_hkld( absref_dicomodo elem1, absref_dicomodo elem2 )
{
   return Alphagreater(elem1.str1, elem2.str1);
}
bool sort_by_hkl ( absref_dicomodo elem1, absref_dicomodo elem2 )
{
   return Alphagreater(elem2.str1, elem1.str1);
}

bool sort_by_condd( absref_dicomodo elem1, absref_dicomodo elem2 )
{
   return Alphagreater(elem1.str2, elem2.str2);
}
bool sort_by_cond ( absref_dicomodo elem1, absref_dicomodo elem2 )
{
   return Alphagreater(elem2.str2, elem1.str2);
}

bool sort_by_ktyped( absref_dicomodo elem1, absref_dicomodo elem2 )
{
   return Alphagreater(elem1.str3, elem2.str3);
}
bool sort_by_ktype ( absref_dicomodo elem1, absref_dicomodo elem2 )
{
   return Alphagreater(elem2.str3, elem1.str3);
}

void sort_col_list(GtkWidget *column, gpointer data)
{
    bool (*sort_by_col)(absref_dicomodo, absref_dicomodo);
    std::vector<absref_dicomodo> absrefv;

    int ncol = GPOINTER_TO_INT(data);
    int ordin = get_int(column, "set_order");
    GtkWidget *treeview = get_widget(column, "father");
    GtkTreeModel *model = gtk_tree_view_get_model(GTK_TREE_VIEW(treeview));
    GtkListStore *list_store = GTK_LIST_STORE(model);
    GtkTreeIter iter;
    int nabsref = n_children(treeview);
    gboolean valid = gtk_tree_model_get_iter_first (model, &iter);
    while (valid)
    {
       absref_dicomodo absref;
       char *str1 = g_new0(char, 10);
       char *str2 = g_new0(char, 60);
       char *str3 = g_new0(char, 12);
       gtk_tree_model_get (model, &iter, 0, &(absref.num), 
                                         1, &str1,
                                         2, &str2,
                                         3, &(absref.prob),
                                         4, &str3, -1);
       CopiaStringa(absref.str1, 10, str1);
       CopiaStringa(absref.str2, 60, str2);
       CopiaStringa(absref.str3, 12, str3);
       valid = gtk_tree_model_iter_next (model, &iter);
       absrefv.push_back(absref);
    }

    if(ordin > 0)
       ordin = -1;
    else
       ordin = 1;
    g_object_set_data(G_OBJECT(column), "set_order", GINT_TO_POINTER(ordin));

    switch (ordin*(ncol+1))
    {
    case -1:
         sort_by_col = sort_by_numd;
         break;
    case -2:
         sort_by_col = sort_by_hkld;
         break;
    case -3:
         sort_by_col = sort_by_condd;
         break;
    case -4:
         sort_by_col = sort_by_probd;
         break;
    case -5:
         sort_by_col = sort_by_ktyped;
         break;
    default:
    case 1:
         sort_by_col = sort_by_num;
         break;
    case 2:
         sort_by_col = sort_by_hkl;
         break;
    case 3:
         sort_by_col = sort_by_cond;
         break;
    case 4:
         sort_by_col = sort_by_prob;
         break;
    case 5:
         sort_by_col = sort_by_ktype;
         break;
    }

    sort(absrefv.begin(), absrefv.end(), sort_by_col);
    RiempiLista(list_store, nabsref, absrefv);
}

void chiudi_absref(GtkWidget *but, GtkWidget *dlg1)
{
   gtk_widget_set_sensitive(dlg1, TRUE);
   gtk_widget_destroy(gtk_widget_get_toplevel(but));
}

void c_getabsref(GtkWidget *but, GtkWidget *dlg1)
{
   int nabsref;
   absref_type *absref;
   get_nabsref_(&nabsref);
   absref = g_new0(absref_type, nabsref);
   get_absref_(absref);

   gtk_widget_set_sensitive(dlg1, FALSE);
   GtkWidget *dlg = gtk_dialog_new();
   gtk_window_set_title (GTK_WINDOW (dlg), "List of systematically absent reflections");
   gtk_container_set_border_width(GTK_CONTAINER(dlg), 8);
   PangoFontDescription *fontlist = get_fontN(MONOSPACE_FONT);
   gtk_widget_set_size_request(dlg, -1, 300);
   int lar, alt;
   get_metrics(fontlist, &lar, &alt);

   GtkWidget *vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(dlg));
   const char *titles[] = { "Num", "  h  k  l", "Extinction condition",
                            "Probability for extinction", "Type"};
   GType types[] = { G_TYPE_INT, G_TYPE_STRING, G_TYPE_STRING, 
                     G_TYPE_FLOAT, G_TYPE_STRING };
// la seguente setta la larghezza (fissa) delle colonne alla lunghezza del titolo)
//   int  sizes[] = { 8*lar, 12*lar, 22*lar, 28*lar, 14*lar};
// la seguente dice al gtk di autoridimensionare le colonne alla larghezza 'ottimale'
   int  sizes[] = { 0, 0, 0, 0, 0};
   int  precs[] = { 0, 0, 0, 3, 0};
   GtkWidget *list =
   new_selection(dlg, vbox1, "absref", 5, titles, sizes, types, precs);
   g_object_set_data(G_OBJECT(dlg), "absref_conn", get_widget(list, "frame"));
   widget_modify_font(list, fontlist);

   for(int i=0; i<5; i++)
  {
      GtkTreeViewColumn *column = gtk_tree_view_get_column(GTK_TREE_VIEW(list), i);
      GtkWidget *label = gtk_tree_view_column_get_widget(column);
      if(label)
         widget_modify_font(label, fontlist);
      gtk_tree_view_column_set_clickable(column, TRUE);
      g_object_set_data(G_OBJECT(column), "set_order", GINT_TO_POINTER(-1));
      g_object_set_data(G_OBJECT(column), "father", list);
      g_signal_connect(G_OBJECT(column), "clicked", G_CALLBACK(sort_col_list),
                 GINT_TO_POINTER(i));
  }

  GtkListStore *list_store = GTK_LIST_STORE(gtk_tree_view_get_model(
                             GTK_TREE_VIEW(list)));
  std::vector<absref_dicomodo> absrefv;
  for(int i=0; i<nabsref; i++)
  {
      absref_dicomodo absref1;
      const char *tipo[] = {"Overlapped", "Single    "};
      int kk = absref[i].ktype;
      if(kk != 1)
         kk = 0;
      absref1.num = absref[i].num;
      absref1.prob = absref[i].prob;
//      CopiaStringa(absref1.str2, 50, absref[i].string);
      ScriviStringa(absref1.str2, 60, "    %s", absref[i].string);
      ScriviStringa(absref1.str1, 10, "%3d%3d%3d", absref[i].hkl[0],
                                      absref[i].hkl[1],
                                      absref[i].hkl[2]);
      CopiaStringa(absref1.str3, 12, tipo[kk]);
      absrefv.push_back(absref1);
  }

  RiempiLista(list_store, nabsref, absrefv);

  GtkTreeSelection *selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
  set_selection_mode(list, GTK_SELECTION_SINGLE);
  (void) g_signal_connect (G_OBJECT (selection), "changed",
                      G_CALLBACK (scelta_riga), dlg);

  GtkWidget *button = CLOSE_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (dlg), button, 1);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(button)),
         GTK_BUTTONBOX_SPREAD);

  (void) g_signal_connect(G_OBJECT (button), "clicked",
         G_CALLBACK(chiudi_absref), dlg1);

   (void) g_signal_connect_swapped(G_OBJECT(dlg), "delete_event",
        G_CALLBACK(gtk_button_clicked), G_OBJECT(button));
   (void) g_signal_connect (G_OBJECT (dlg), "delete_event",
                      G_CALLBACK(true_cb), NULL);
  gtk_widget_show_all(dlg);
}

GtkWidget* create_spacedialog ()
{
  GtkWidget *spacewin;
  GtkWidget *vbox1;
  GtkWidget *vbox2;
  GtkWidget *hbox1;
  GtkWidget *hbox2;
  GtkWidget *hbox3;
  GtkWidget *hbox4;
  GtkWidget *buttonz6;
  GtkWidget *frame1;
  GtkWidget *frame2;
  GtkWidget *frame3;
  GtkWidget *frame4;
  GtkWidget *button;
  GtkWidget *listext1;
  GtkWidget *listext2;
  GtkWidget *listspace;
  GtkWidget *combo;
  GtkWidget *entry;
  GtkWidget *hseparator1;
  GtkWidget *ok_space;
  GtkWidget *cancel_space;
  char      filspg[256], *spg;
  GList     *glist=NULL;
  FILE *fp;
  int vspace = 4;
#ifndef GTK_TOOLTIP
      GtkTooltips *tooltips = gtk_tooltips_new();
#endif

  spacewin = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (spacewin), "Find space group");

  vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(spacewin));
  gtk_container_set_border_width (GTK_CONTAINER (vbox1), 4);

  hbox1 = hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);

//
// Prima lista
//

  frame1 = FRAME_NEW ("Select extinction group", MyBLUE);
  g_object_set_data (G_OBJECT (spacewin), "frame_extinction", frame1);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (hbox1), frame1, TRUE, TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(frame1), 6);

  vbox2 = vbox_new (FALSE, 0);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (frame1), vbox2);

  listext1 = createSelectionM (spacewin, vbox2, extin_labels, "lista_gruppi_estinzione", 
                NEXTINLABELS, MyBLUE);
  g_object_set_data (G_OBJECT (spacewin), "extinctionlista1", listext1);
  set_widget_font(listext1, fontn);
  gtk_widget_set_size_request(get_widget(listext1, "scrollwin"),-1,200);
  gtk_widget_show (listext1);

//
// Seconda lista con pseudotraslazione
//
  if (kpseudo == 1)
  {
    frame1 = FRAME_NEW ("Select extinction group (pseudo applied)", MyBLUE);
    g_object_set_data (G_OBJECT (spacewin), "frame_extinction", frame1);
    gtk_widget_show (frame1);
    gtk_box_pack_start (GTK_BOX (hbox1), frame1, TRUE, TRUE, 0);
    gtk_container_set_border_width(GTK_CONTAINER(frame1), 6);

    vbox2 = vbox_new (FALSE, 0);
    gtk_widget_show (vbox2);
    gtk_container_add (GTK_CONTAINER (frame1), vbox2);
    listext2 = createSelectionM (spacewin, vbox2, extin_labels, "lista_gruppi_estinzione", NEXTINLABELS, MyBLUE);
    g_object_set_data (G_OBJECT (spacewin), "extinctionlista2", listext2);
    set_widget_font(listext2, fontn);
    gtk_widget_set_size_request(get_widget(listext2, "scrollwin"),-1,200);
    gtk_widget_show (listext2);

    g_signal_connect(G_OBJECT(gtk_tree_view_get_selection(GTK_TREE_VIEW(listext2))),"changed",
         G_CALLBACK(sel_to_extinction),GINT_TO_POINTER(2));
  }

//
// Lista gruppi spaziali
//
  frame2 = FRAME_NEW ("Select space group", MyBLUE);
  g_object_set_data (G_OBJECT (spacewin), "frame_space", frame2);
  gtk_widget_show (frame2);
  gtk_box_pack_start (GTK_BOX (hbox1), frame2, TRUE, TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(frame2), 6);

  listspace = createSelectionM (spacewin, frame2, spgr_labels, "lista_gruppi_spaziali", NSPGRLABELS, MyBLUE);
  g_object_set_data (G_OBJECT (spacewin), "spacelista", listspace);
  set_widget_font(listspace, fontn);
  gtk_widget_set_size_request(get_widget(listspace, "scrollwin"),-1,200);
  gtk_widget_show (listspace);

  hbox3 = hbox_new (FALSE, 0);
  gtk_widget_show (hbox3);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox3, FALSE, FALSE, 0);
//
// Inserimento gruppo spaziale da parte dell'utente
//
  frame3 = gtk_frame_new (NULL);
  gtk_widget_show (frame3);
  gtk_box_pack_start (GTK_BOX (hbox3), frame3, TRUE, TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(frame3), 6);

  hbox2 = hbox_new (FALSE, 0);
  gtk_widget_show (hbox2);
  gtk_container_set_border_width (GTK_CONTAINER (hbox2), vspace);
  gtk_container_add (GTK_CONTAINER (frame3), hbox2);

  button = CHECK_BUTTON_WITH_LABEL("User's space group", LABELCOLOR);
  g_object_set_data (G_OBJECT (spacewin), "spacebutton", button);
  gtk_widget_show (button);
  gtk_box_pack_start (GTK_BOX (hbox2), button, FALSE, FALSE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(button), 6);

  combo = create_combo_str(NULL, NULL);
  g_object_set_data (G_OBJECT (spacewin), "combo_space_user", combo);
  entry = get_widget(combo, "entry");
  g_object_set_data (G_OBJECT (spacewin), "entry_spacegroup", entry);
  gtk_widget_set_sensitive(combo, FALSE);

  ScriviStringa(filspg,sizeof(filspg),"%s%c%s.spg", files_dir, DIR_SEPAR, MR_PACKAGE);
  fp = fOpen(filspg, "r");
  if(fp != NULL)
  {
     glist = NULL;
     spg = g_new0(char, 17);
     while(fgets(filspg, 256, fp) != NULL)
     {
        if(filspg[0] != '$')
        {
            CopiaStringan(spg, 17, filspg, 12);
            *(spg + 12) = '\0';
            glist = g_list_append(glist, DuplicaStringa(spg));
        }
     }
     fclose(fp);
  }
  set_popdown_strings( combo, glist);
  g_list_free (glist);

  gtk_widget_show(combo);
  gtk_box_pack_start( GTK_BOX(hbox2), combo, TRUE, FALSE, 0);

//
// Zoom sui riflessi estinti
//
  frame4 = gtk_frame_new (NULL);
  g_object_set_data (G_OBJECT (spacewin), "frame_zoom", frame4);
  gtk_widget_show (frame4);
  gtk_box_pack_start (GTK_BOX (hbox3), frame4, TRUE, TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(frame4), 6);
  gtk_widget_set_sensitive(frame4, FALSE);

  hbox4 = hbox_new (FALSE, 0);
  gtk_widget_show (hbox4);
  gtk_container_set_border_width (GTK_CONTAINER (hbox4), vspace);
  gtk_container_add (GTK_CONTAINER (frame4), hbox4);

  buttonz6 = xpm_button("output.xpm");
  gtk_widget_show (buttonz6);
  gtk_box_pack_start (GTK_BOX (hbox4), buttonz6, FALSE, FALSE, 0);
#ifdef GTK_TOOLTIP
  gtk_widget_set_tooltip_text( buttonz6, "List of systematically absent reflections");
#else
  gtk_tooltips_set_tip (tooltips, buttonz6, "List of systematically absent reflections", NULL);
#endif

// Bottoni OK e CANCEL
//
  hseparator1 = hseparator_new ();
  gtk_widget_show (hseparator1);
  gtk_box_pack_start (GTK_BOX (vbox1), hseparator1, FALSE, FALSE, 0);

  ok_space = OK_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (spacewin), ok_space, 1);
  gtk_widget_show (ok_space);

  cancel_space = CANCEL_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (spacewin), cancel_space, 2);
  gtk_widget_show (cancel_space);
  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(ok_space)),
         GTK_BUTTONBOX_SPREAD);

  g_signal_connect(G_OBJECT(gtk_tree_view_get_selection(GTK_TREE_VIEW(listext1))),"changed",
           G_CALLBACK(sel_to_extinction),GINT_TO_POINTER(1));

  g_signal_connect(G_OBJECT(gtk_tree_view_get_selection(GTK_TREE_VIEW(listspace))),"changed",
           G_CALLBACK(sel_to_spacegroup), listspace);

  g_signal_connect(G_OBJECT(buttonz6),"clicked",G_CALLBACK(c_getabsref),spacewin);
  g_signal_connect(G_OBJECT(button),"clicked",G_CALLBACK(selection_user),NULL);

  g_signal_connect(G_OBJECT(ok_space),"clicked",G_CALLBACK(ok_spacedialog),GINT_TO_POINTER(1));

  g_signal_connect(G_OBJECT(cancel_space),"clicked",G_CALLBACK(exit_spacedialog),NULL);

  g_signal_connect(G_OBJECT(spacewin),"delete_event",G_CALLBACK(exit_spacedialog),NULL);

  g_signal_connect_swapped(G_OBJECT(spacewin),"delete_event",G_CALLBACK(gtk_button_clicked),G_OBJECT(cancel_space));

  return spacewin;
}

#ifdef OLDCELLDIALOG
GtkWidget* create_celldialog (GCallback cb1)
{
  GtkWidget *window1;
  GtkWidget *vbox1;
  GtkWidget *frame1;
  GtkWidget *list;
  GtkWidget *ok_space;
  GtkWidget *cancel_space;

  window1 = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (window1), "    Plausible cell parameters    ");
  gtk_widget_set_size_request(window1,800,250);

  vbox1 = gtk_dialog_get_content_area(GTK_DIALOG(window1));
  gtk_container_set_border_width(GTK_CONTAINER(vbox1), 6);

  frame1 = FRAME_NEW ("Select cell", MyBLUE);
  g_object_set_data (G_OBJECT (window1), "frame_lista", frame1);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (vbox1), frame1, TRUE, TRUE, 0);
  gtk_container_set_border_width(GTK_CONTAINER(frame1), 6);

  list = createSelectionM (window1, frame1, space_labels, "lista_gruppi_spaziali", 
          NSPACELABELS, MyBLUE);
  set_widget_font(list, fontn);
  gtk_widget_show (list);

  ok_space = OK_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), ok_space, 1);
  gtk_widget_show(ok_space);
  g_signal_connect(G_OBJECT(ok_space), "clicked",
         G_CALLBACK(cb1), GINT_TO_POINTER(1));

  cancel_space = CANCEL_button();
  gtk_dialog_add_action_widget (GTK_DIALOG (window1), cancel_space, 2);
  gtk_widget_show(cancel_space);
  g_signal_connect(G_OBJECT(cancel_space), "clicked",
         G_CALLBACK(exit_spacedialog), GINT_TO_POINTER(1));
  g_signal_connect_swapped(G_OBJECT(window1),"delete_event",
     G_CALLBACK(gtk_button_clicked),G_OBJECT(cancel_space));


  g_signal_connect(G_OBJECT(gtk_tree_view_get_selection(GTK_TREE_VIEW(list))),
         "changed", G_CALLBACK(sel_to_cell), NULL);

  gtk_button_box_set_layout(GTK_BUTTON_BOX(gtk_widget_get_parent(ok_space)),
         GTK_BUTTONBOX_SPREAD);
  return window1;

}
#endif

void open_spacegroup_dlg(char *stringSG, int n_space, float fmerito[],
                         int *kselect, int isymb[], char kstring_space_select[], int lung)
{
  int i;
  char **line = g_new0(char *, NEXTINLABELS);
//corr  GtkWidget *tb;

  lstrout = lung;
  for (i=0;i<NEXTINLABELS;i++)
       line[i] = g_new0(char, 40);

  kpseudo = *kselect;
  rowspace = -1;
  oldsel = 0;
  string_to_vector(stringSG,spacegroup);
  n_spacegroup = n_space/(kpseudo+1);
  spacegroup_dialog = create_spacedialog();
  if (kpseudo == 1)
  {
     for (i=0;i<n_spacegroup;i++)
     {
        ScriviStringa(line[0], 40, "%3d) %-15s", i+1, spacegroup[2*i]);
        ScriviStringa(line[1], 40, "%.3f", fmerito[2*i]);
        add_line_to_listM(get_widget(spacegroup_dialog, "extinctionlista1"),  line);
        ScriviStringa(line[0], 40, "%3d) %-15s", i+1, spacegroup[2*i+1]);
        ScriviStringa(line[1], 40, "%.3f", fmerito[2*i+1]);
        add_line_to_listM(get_widget(spacegroup_dialog, "extinctionlista2"),  line);
     }
  }
  else
  {
     for (i=0;i<n_spacegroup;i++)
     {
        ScriviStringa(line[0], 40, "%3d) %-18s", i+1, spacegroup[i]);
        ScriviStringa(line[1], 40, "%.3f", fmerito[i]);
        add_line_to_listM(get_widget(spacegroup_dialog, "extinctionlista1"),  line);
     }
  }
  for (i=0;i<NEXTINLABELS;i++)
       g_free(line[i]);
  g_free(line);

  gtk_window_set_transient_for(GTK_WINDOW(spacegroup_dialog), GTK_WINDOW(finestre[0]));
  gtk_widget_show(spacegroup_dialog);

  gtk_main();
  *kselect = rowspace+1;
  ScriviStringa(kstring_space_select,lstrout, "%10s",string_space_select);
}

#ifdef OLDCELLDIALOG
void open_cell_dlg(int ibest,float cellsav[][6],float volc[],float ameff[],int m20sav[],
                   float shiftsav[],int Noindsav[], stringa20 lauecell[])
{
  int i;
  char **line = g_new0(char *, NSPACELABELS);

  n_spacegroup = ibest;
  spacegroup_dialog = create_celldialog(G_CALLBACK(end_celldialog));
  clear_list(get_widget(spacegroup_dialog, "lista_gruppi_spaziali"));
  for (i=0;i<NSPACELABELS-1;i++)
       line[i] = g_new0(char, 10);
  line[NSPACELABELS-1] = g_new0(char, 21);
  for (i=0;i<ibest;i++)
  {
       ScriviStringa(line[0], 10, "%3d", i+1);
       ScriviStringa(line[1], 10, "%-8.5f", cellsav[i][0]);
       ScriviStringa(line[2], 10, "%-8.5f", cellsav[i][2]);
       ScriviStringa(line[3], 10, "%-8.5f", cellsav[i][4]);
       ScriviStringa(line[4], 10, "%-8.5f", cellsav[i][1]);
       ScriviStringa(line[5], 10, "%-8.5f", cellsav[i][3]);
       ScriviStringa(line[6], 10, "%-8.5f", cellsav[i][5]);
       ScriviStringa(line[7], 10, "%-6.1f", volc[i]);
       if(ameff[i] < 0)
          ScriviStringa(line[8], 10, "   -   ");
       else
          ScriviStringa(line[8], 10, "%-6.5f", ameff[i]);
       ScriviStringa(line[9], 10, "%5d", m20sav[i]);
       ScriviStringa(line[10], 10, "%8.3f", shiftsav[i]);
       ScriviStringa(line[11], 10, "%3d", Noindsav[i]);
       CopiaStringan(line[12], 21, (const char *)lauecell[i], 20);
       line[12][20] = '\0';
       add_line_to_listM(get_widget(spacegroup_dialog, "lista_gruppi_spaziali"),  line);
  }
  select_row(get_widget(spacegroup_dialog, "lista_gruppi_spaziali"), 0);

  for (i=0;i<NSPACELABELS;i++)
       g_free(line[i]);
  g_free(line);
  gtk_window_set_transient_for(GTK_WINDOW(spacegroup_dialog), GTK_WINDOW(finestre[0]));
  gtk_widget_show(spacegroup_dialog);
  gtk_main();
}
#endif

long cc_nint(float fnumber)
{
    long inumber = 0;

    if (fnumber >= 0)
        inumber = (long) (fnumber + 0.5);
    else if(fnumber < 0)
        inumber = (long) (fnumber - 0.5);

    return inumber;
}

GtkWidget *xpm_checkbutton( GtkWidget *parent,
                          const gchar  *xpm_filename)
{
    GtkWidget *button;
    GtkWidget *pixmapwid;

    /* Now on to the xpm stuff */
    pixmapwid = create_image(xpm_filename);
    gtk_widget_show(pixmapwid);

    /* Create a new button */
    button = gtk_toggle_button_new ();
    gtk_container_add (GTK_CONTAINER (button), pixmapwid);
    gtk_widget_show(button);
    return button;
}

//void c_indexing(gpointer w, gpointer data)
//{
//    int iCode = GPOINTER_TO_INT(data);
//    run_indexing_(&iCode);
//}

extern "C"  {

void c_open_spacegroup_(char *list, int *n_elem, float fmerito[], int *kselect, 
                        int isymb[], char *string_space_select, int *len)
{
     open_spacegroup_dlg(list, *n_elem, fmerito, kselect, isymb, string_space_select, *len);
     *len = (int) strlen(string_space_select);
}

#ifdef OLDCELLDIALOG
void c_open_cell_(int *ibest,float cellsav[][6],float volc[],float ameff[],
                  int m20sav[],float shiftsav[],int Noindsav[], stringa20 lauecell[])
{
     open_cell_dlg(*ibest,cellsav,volc,ameff,m20sav,shiftsav,Noindsav, lauecell);
}
#endif
}

