module profile_function
   implicit none

   integer, parameter, public :: PEARSON7 = 1
   integer, parameter, public :: PVOIG    = 2
   integer, parameter, public :: TCHZ     = 3

   real, allocatable :: rapIcalc (:) ! rapIcalc (i,nph)    : rapporto di intensita'

   type :: profinfo_type
     integer                         :: iniz,ifin
     real, dimension(:), allocatable :: func
     real                            :: fconst
   end type profinfo_type

   type(profinfo_type), dimension(:), allocatable :: profi

contains

   subroutine AllocaRietnew(iAction,nref)
   USE progtype,only:ALLOCA
!
   implicit none
   integer, intent(in)           :: iAction
   integer, intent(in), optional :: nref
   integer, dimension(10)        :: ierv
!
   ierv = 0
!
   if (iAction == ALLOCA) then
!corr      if (.not. allocated(betariet))  allocate (betariet  (1:nref)    , stat = ierv( 3))
      if (.not. allocated(rapIcalc))  allocate (rapIcalc  (1:nref)    , stat = ierv( 9))
!corr      if (.not. allocated(phkl))      allocate (phkl      (1:nref,1:4), stat = ierv(10))
      if (sum(iabs(ierv)) /= 0) stop 'RIETNEW allocation error'
   else
      !if (allocated(betariet))deallocate (betariet,rapIcalc,phkl, stat=ierv(1))
      if (allocated(rapIcalc))deallocate (rapIcalc, stat=ierv(1))
      if (ierv(1).ne.0) stop 'RIETNEW deallocation error'
   endif
!
   end subroutine AllocaRietnew

!-----------------------------------------------------------------------------------------------------

   subroutine close_profile()
!
   if (allocated(profi)) deallocate(profi)
!   
   end subroutine close_profile

end module profile_function
