MODULE progproject

!!!FIXME - Fare open del file di output
!!!FIXME - Riscrivere GenInfoV2
   implicit none
   character(len=*), parameter :: PRJEXT = 'expo'

CONTAINS

   subroutine writeproject(nameproject)
   USE fileutil
   USE atom_type_util
   USE variables, only: atm,lconn,ref
   USE General, only:cell, celem
   USE sinterface
   USE spginfom
   USE elements
   USE proginterface
   USE datasetmod
   USE reflection_type_util
   USE sannel
   USE model_util
   USE rrestr
   USE rietv
   USE peak_mod
   character(len=*), intent(in)                  :: nameproject
   integer                                       :: unitp
   type(dataset_type)                            :: dataset
   type(file_handle)                             :: fileh
!
   call fileh%fopen(nameproject,ios='wb')
   if (fileh%good()) then
       unitp = fileh%handle()
!
       call save_general_info(unitp)
!
!      save cell on project file
       call save_cell_bin(unitp,cell)
!
!      save space group info on project file
!FIXME - testare in situazioni in cui non trova lo space group
       call save_space_bin(unitp,space=init_spaceg_type(spaceg_string()))
!      save chemical species
!corr       call nk_to_elem(elem)
       call save_elem_bin(unitp,celem)
!
!      save coordinates on project file
       call save_structure_bin(unitp,atm,lconn)
!
!      Save dataset
       call expo_to_dataset(dataset)
       call dataset%save_bin(unitp)
!
!      save reflections
       call save_refl_bin(unitp,ref)
!
!      save models from SA
       call save_sa(unitp,goptim)
       call save_models_bin(unitp,samodel) 
!!!!!! FIXME salvare le condizioni di SA
!
!      Rietveld
       call save_restraints(unitp,resvr)
!
!      save peak positions
       call save_peaks_bin(unitp,pkind)
!
       close(unitp)
!corr            write(0,*)'scritto il file progetto '//trim(nameproject)
       call upd_recProjects(trim(nameproject) // char(0))
   else
!FIXME - migliora usando handle_open_error
       write(0,*)'error opening file'//trim(nameproject)
   endif
   
   end subroutine writeproject

!-----------------------------------------------------------------------------------------------

   integer function readproject(nameproject)  result(ierp)
   USE fileutil
   USE variables, only: ref
   USE atom_type_util
   USE connect_mod
   USE sinterface
   USE ilmviewmod
   USE drawatoms
   USE General, only:cell, jobname, celem
   USE sinterface
   USE elements
   USE proginterface
   USE conteggi, only:npunti
   USE datasetmod
   USE view
   USE enable_amb
   USE messagemod
   USE reflection_type_util
   USE proginterface
   USE sannel
   USE model_util
   USE errormod
   USE molcom, only:jscreen
   USE rrestr
   USE rietv
   USE peak_mod
   character(len=*), intent(in) :: nameproject
   type(file_handle)            :: fileh
   integer                      :: unitp     !!!!,ier
   type(atom_type), dimension(:), allocatable :: atom
   type(bond_type), dimension(:), allocatable :: legm
!corr   type(element_type), dimension(:), allocatable :: elem
   type(dataset_type) :: dataset
   type(reflection_type), dimension(:), allocatable :: refl
   type(error_type) :: errp
   integer                                          :: nref
   integer :: vaction
!
   call fileh%fopen(nameproject,'b')
   if (fileh%good()) then

       unitp = fileh%handle()
       call read_general_info(unitp,errp)
       if (errp%signal) go to 10

       call read_cell_bin(unitp,cell(1:6),errp)
       if (errp%signal) go to 10

       call read_space_bin(unitp,errp)
       if (errp%signal) go to 10

       call read_elem_bin(unitp,celem,errp)
       if (errp%signal) go to 10

       call read_structure_bin(unitp,atom,legm,errp)
       if (errp%signal) go to 10

       call read_data_bin(dataset,unitp,errp)
       if (errp%signal) go to 10

       call read_refl_bin(unitp,refl,errp)
       if (errp%signal) go to 10

       call read_sa(unitp,goptim,errp)
       if(errp%signal) go to 10

       call read_models_bin(unitp,samodel,nsamodel,errp) 
       if(errp%signal) go to 10

       call read_restraints(unitp,resvr,errp) 
       if(errp%signal) go to 10
!
!      Find additional info in binary, error is not important
!!!FIXME - to read peaks is important save backgr (forse anche ttetaczero/ycountoss) forse in dataset
       call read_peaks_bin(unitp,pkind,errp)
       if(errp%signal) go to 20

20     if (errp%signal) then
           call errp%as_warn()  ! Set error as warning
           call errp%add(' from project file '//trim(nameproject))
           call errp%print()
       endif

       call init_dati()  ! necessary for compatibility with old bin file

       !write(0,*)'letto il file progetto '//trim(nameproject)
       call elem_to_nk(celem)
       call update_model(atom,legm)
       if (numatomtype(atom) > 0 .and. jscreen > 0) then
           call ilmview_open(nameproject)
           call draw_atoms(atom,legm)
           !call stampa_struttura(atom,kpr=0)
           call abilita_tasti('structure')
       endif
       nref = numrefl(refl)
       if (nref > 0) then
           !call reallocate(ref,nref,.false.)
           call new_reflections(ref,nref)
           ref(:) = refl(:)
           call ref_to_expo(refl)
       endif
       call dataset_to_expo(dataset)
       if (npunti > 0) then    !!!! FIXME - rivedi questa parte
           if (jscreen > 0) then
               call AbilitaPaned(1)
               call init_messages()
               call write_message_pattern(nameproject)
               if (numpeaks(pkind) > 0) then
                   vaction = 5
               else
                   vaction = 1
               endif
               call vedinew(vaction,1,npunti)
               call abilita_tasti('pattern')
               call vedinew(1,1,npunti)
               call SetWindowTitle(trim(jobname)//' ['//trim(nameproject)//']')
           endif
       endif
       call fileh%fclose()
       ierp = 0
   else
       ierp = 1
   endif

   return

10 call errp%add(' from project file '//trim(nameproject))
   call errp%print()
   ierp = 2

   end function readproject

!-----------------------------------------------------------------------------------------------

   subroutine save_general_info(unitp)
   USE General
   integer, intent(in) :: unitp
   write(unitp) fname(:), StructureName, jobname
   write(unitp) knw
!corr        write(0,*)'fout=',fname(OUT_FILE)
   end subroutine save_general_info

!-----------------------------------------------------------------------------------------------

   subroutine read_general_info(unitp,err)
   USE General
   USE errormod
   integer, intent(in)           :: unitp
   type(error_type), intent(out) :: err
   integer                       :: ier
   read(unitp, iostat=ier) fname(:), StructureName, jobname
   read(unitp, iostat=ier) knw
   if (ier /= 0) then
       call err%set('Error on reading general information')
   endif
   end subroutine read_general_info

END MODULE progproject

!-----------------------------------------------------------------------------------------------
   subroutine writeprojectwin(nameproject)
   USE progproject
   USE strutil
   implicit none
   character(len=*), intent(in) :: nameproject
!
   call writeproject(remc0(nameproject))
!
   end subroutine writeprojectwin

!-----------------------------------------------------------------------------------------------
   integer function readprojectwin(nameproject)  result(ierp)
   USE progproject
   USE strutil
   implicit none
   character(len=*), intent(in) :: nameproject
!
   ierp = readproject(remc0(nameproject))
!
   end function readprojectwin

