module qe_frm

implicit none 

CONTAINS

   subroutine read_qe_file(filename,atom,cell,spg,errc)
   USE unit_cell
   USE atom_type_util
   USE fileutil
   USE elements
   USE spginfom
   USE errormod
   USE strutil
   character(len=*), intent(in)                            :: filename
   type(atom_type), dimension(:), allocatable, intent(out) :: atom
   real, dimension(6), intent(out)                         :: cell
   type(spaceg_type), intent(out)                          :: spg
   type(error_type), intent(out)                           :: errc
   type(file_handle)                                       :: fnw
   integer                                                 :: jout,ier,nline
   character(len=200)                                      :: line
   real, dimension(6) :: rnum
!
   call fnw%fopen(filename,'r')
   if (.not.fnw%good()) return
!
   jout = fnw%handle()
   call find_key_file(jout,'celldm',nline,line,ier)
   call parse_line_reals(line,[2,4,6],rnum(1:3),ier)
   read(jout,'(a)')line
   call parse_line_reals(line,[2,4,6],rnum(4:6),ier)
!!!TODO convert in ang from a.u.
   write(0,*)'CELL=',rnum
!
   call fnw%fclose()
   end subroutine read_qe_file

!-----------------------------------------------------------------------------------------------

   logical function is_espresso_file(filename)
!
!  Check if the file is a CRYSTAL file
!
   USE fileutil
   character(len=*), intent(in)              :: filename
   type(file_handle)                         :: fnw
   integer                                   :: i
   character(len=200)                        :: line
   integer                                   :: ier
!
   is_espresso_file = .false.
   call fnw%fopen(filename,'r')
   if (.not.fnw%good()) return
!
   do while (.not.is_espresso_file)
     read(fnw%handle(),'(a)',iostat=ier)line
     if (ier /= 0) exit
     is_espresso_file = index(line,"Quantum ESPRESSO suite") > 0
   enddo 
   call fnw%fclose()
!
   end function is_espresso_file

end module qe_frm
